; FLAG'S BIT LAYOUT
_VMODE EQU  0
_C_STA EQU  1
_FLEX_C EQU 2

_CAPS  EQU  4
_RUS   EQU  5
_K_SS  EQU  6
_K_CS  EQU  7

; FLAG1'S BIT LAYOUT
_OVER  EQU  0
_TRANS EQU  1
_FASTR EQU  2
_BREAK EQU  3
_ROLL  EQU  4

; SWITCH AREA FOR HI RESOLUTION MODE
HI_MOD:
       JP   C_H
       JP   _P_H
       JP   CLRL_H
       JP   SCO_H
       JP   RRL_H
; ... FOR MIDIUM RES MODE
M_MODE:
       JP   C_M
       JP   _P_M
       JP   CLRL_M
       JP   SCO_M
       JP   RRL_M

; CONVERT WIN-RELATIVE TO ABS & CHECK
CHKCOR: LD   HL,(W_X1)
       ADD  HL,BC
       LD   B,H
       LD   C,L
_CHKCO: OR   A          ; ONLY CHECK
       EX   AF,AF'
       LD   A,(W_X1)
       CP   C
       JR   Z,_chs1
       JR   NC,_chx
_chs1: LD   A,(W_X2)
       CP   C
       JR   NC,chsh1
_chx:  LD   C,A
       EX   AF,AF'
       SCF
       EX   AF,AF'
chsh1: LD   A,(W_Y1)
       CP   B
       JR   Z,_chs2
       JR   NC,_chy
_chs2: LD   A,(W_Y2)
       CP   B
       JR   NC,chsh2
_chy:  LD   B,A
       SCF
       RET
chsh2: EX   AF,AF'
       RET

; SET CURSOR (W-RELATIVE & CHECK)
GOXY:  CALL CHKCOR
_GOXY: LD   (CUR_X),BC ;SET ABS & NO CHECK
       CALL EV_COR
       LD   (SCR_AD),HL
       RET

CUR_IN: DI
       DEC  (IX+_C_CNT)
       RET  NZ
       LD   A,(C_MAX)
       LD   (C_CNT),A
       LD   A,(FLAG)
       XOR  2         ;C_STAT bit
       LD   (FLAG),A
       LD   A,(C_ACT)
       OR   A
       RET  NZ
c_inv: LD   HL,C_I
sw:    LD   (SW_DO+1),HL
       LD   HL,(SCR_AD)
       LD   DE,SV_ARE
       JP   SW_C

CUR_AC:    DI
       DEC  (IX+_C_ACT)
       JR   Z,ca_sh
       RET  P
       LD   (IX+_C_ACT),0
       RET
ca_sh: LD   HL,C_A
       CALL sw
       BIT  _C_STA,(IX+_FLAG)
       JR   NZ,c_inv
       RET

CUR_PA:    DI
       LD   A,(C_ACT)
       INC  A
       LD   (C_ACT),A
       DEC  A
       RET  NZ
       LD   HL,C_P
       JR   sw

; SW_C PROCEDURES
C_H:   LD   BC,(C_BEG)
c_lp:  DEC  C
       CALL M,SW_DO
       LD   A,40
       CALL ADD_HL_A
       INC  DE
       DJNZ c_lp
       RET

C_M:   PUSH HL
       CALL C_H
       POP  HL
       PUSH HL
       LD   A,20H
       ADD  A,H
       LD   H,A
       CALL C_H
       POP  HL
       LD   A,80H
       ADD  A,H
       LD   H,A
       JR   NC,C_M

; SET OF SW_DO PROCEDURES
C_P:   LD   A,(DE)
       LD   (HL),A
       RET
C_A:   LD   A,(HL)
       LD   (DE),A
       RET
C_I:   LD   A,(HL)
       CPL
       LD   (HL),A
       RET

; PUT_CH SWITCHABLE PART'S
_P_H:  EX   AF,AF'
       LD   A,(DE)
       INC  DE
       BIT  _OVER,(IX+_FLAG1)
       JR   Z,_psh
       XOR  (HL)
_psh:  LD   (HL),A
       BIT  _TRANS,(IX+_FLAG1)
       JR   NZ,_ptr
       SET  7,H
       LD   A,(IY+0)
       LD   (HL),A
       RES  7,H
       INC  IY
_ptr:  ADD  HL,BC
       EX   AF,AF'
       DEC  A
       JR   NZ,_P_H
       RET

_P_M:  EX   AF,AF'
       LD   A,(DE)
       LD   B,A
       INC  DE
       PUSH DE
       SET  5,H
       CALL ccol
       SET  7,H
       CALL ccol
       RES  7,H
       RES  5,H
       CALL ccol
       SET  7,H
       CALL ccol
       RES  7,H
       LD   B,0
       ADD  HL,BC
       POP  DE
       INC  IY
       INC  IY
       EX   AF,AF'
       DEC  A
       JR   NZ,_P_M
       RET
; SUBROUTINE FOR _P_M
ccol:  RR   B
       LD   A,(IY+1)
       JR   NC,$+5
       LD   A,(IY+0)
       RLCA
       RLCA
       RLCA
       BIT  2,A
       JR   Z,$+3
       LD   A,(HL)
       AND  0B8H
       LD   D,A
       RR   B
       LD   A,(IY+1)
       JR   NC,$+5
       LD   A,(IY+0)
       BIT  7,A
       JR   Z,$+3
       LD   A,(HL)
       AND  47H
       OR   D
       BIT  _OVER,(IX+_FLAG1)
       JR   Z,$+3
       XOR  (HL)
       LD   (HL),A
       RET

; PUT CHAR PROC
_PUT_C: LD   L,A
       LD   H,0
       LD   B,H
       ADD  HL,HL
       ADD  HL,HL
       ADD  HL,HL
       LD   DE,SG_BEG
       ADD  HL,DE
       EX   DE,HL
_pt_ch:LD   C,40
       LD   IY,ARR_CO
       LD   HL,(SCR_AD)
       LD   A,8
       JP   SW_PUT


; ENCODING ROUTINE
encode: LD   B,A
       RLCA
       RLCA
       RLCA
       AND  7
       LD   HL,SG_ENC
       CALL ADD_HL_A
       LD   A,(HL)
       BIT  4,B
       JR   Z,esh
       RLCA
       RLCA
       RLCA
       RLCA
esh:   AND  0F0H
       XOR  B
       AND  0F0H
       XOR  B
       RET

;CONVERT XY TO SCREEN ADRESS
EV_COR: OR   A
       BIT  _VMODE,(IX+_FLAG)
       JR   Z,gsh
       RR   C
gsh:   PUSH AF
       CALL Bx320
       LD   B,40H
       ADD  HL,BC
       POP  AF
       RET  NC
       SET  5,H
       RET

Bx320: LD   L,B
       LD   H,0
HLx320:ADD  HL,HL
       ADD  HL,HL
       ADD  HL,HL
       LD   D,H
       LD   E,L
       ADD  HL,HL
       ADD  HL,HL
       ADD  HL,DE
       ADD  HL,HL
       ADD  HL,HL
       ADD  HL,HL
       RET

;CALCULATE NEXT SCREEN POSITION
ADV:   LD   HL,(SCR_AD)
ADV1:  BIT  _VMODE,(IX+_FLAG) ;-"- FROM HL
       JR   Z,psh
ADV2:  LD   A,20H ;-"- FOR HI MODE ONLY
       XOR  H
       LD   H,A
       AND  20H
       RET  NZ
psh:   INC  HL
       RET

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;     Protection
rom_chk::
       ld   bc,3fffh
       xor  a
       ld   h,a
       ld   l,a
rc_lp: add  a,(hl)
       adc  a,0
       inc  hl
       rrca
       xor  0b9h
       dec  bc
       ld   d,a
       ld   a,b
       or   c
       ld   a,d
       jr   nz,rc_lp
       dec  a
       ret  z
       ld   a,r
       ld   l,a
       ld   h,0dch                     ; is BDOS adress
       inc  (hl)
       and  7fh
       ret  nz
       ld   hl,mes_rck
rc_plp:xor  (hl)
       inc  hl
       call nz,conout
       jr   nz,rc_plp
       ld   a,1
       rst  18h
rc_hlt:ld   hl,PAL_BUF
       ld   b,16
rc__1: inc  (hl)
       inc  hl
       djnz rc__1
       call SET_PAL
       ld   b,25
       ei
rc__2: halt
       djnz rc__2
       jr   rc_hlt
mes_rck:
       db   0Dh,16h,0Ah,58h,69h,43h,11h,13h,02h,08h,0Eh,01h,4Ah,0Eh
       db   69h,69h,48h,09h,0Dh,18h,11h,01h,4Ah,0Eh,70h,22h,17h,16h
       db   00h,53h,72h,17h,16h,16h,11h,74h,54h,1Bh,4Fh,43h,0Ch,01h
       db   1Ah,1Dh,07h,1Bh,10h,4Bh,00h,00h,2Eh
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

;------------------------------
; SW PROC FOR ROLL RIGHT/LEFT
RRL_H: PUSH IY
       PUSH BC
       LD   B,8
RRL_HL:XOR  A
       CALL SW_LINE
       LD   A,(IY+0)
       SET  7,H
       CALL SW_LINE
       RES  7,H
       LD   DE,40
       ADD  HL,DE
       INC  IY
       DJNZ RRL_HL
       POP  BC
       POP  IY
       DJNZ RRL_H
       RET

RRL_M: PUSH HL
       LD   HL,40
       LD   (TMP_W),HL
       LD   HL,SW_LINE
       LD   (SW_CLR+1),HL
       POP  HL
RRL_ML:PUSH IY
       PUSH BC
       LD   B,8
       CALL CLRL_M
       POP  BC
       POP  IY
       DJNZ RRL_ML
       RET

;SWITCH PROC FOR CLEAR/ROLL ROUTINE
CLRL_M: LD   A,(IY+1)
       LD   D,A
       RLA
       RLA
       RLA
       XOR  D
       AND  0B8H
       XOR  D
       CALL SW_CLR
       SET  5,H
       CALL SW_CLR
       BIT  _TRANS,(IX+_FLAG1)
       JR   NZ,_FRS1_
       SET  7,H
       CALL SW_CLR
       RES  5,H
       CALL SW_CLR
       RES  7,H
_FRS1_:RES  5,H
       LD   DE,(TMP_W)
       ADD  HL,DE
       INC  IY
       INC  IY
       DJNZ CLRL_M
       RET

CLRL_H: SRL  C
       LD   A,C
       JR   NC,$+3
       INC  C
       PUSH HL
       EXX
       LD   C,A
       POP  HL
       CALL ADV2
       LD   B,0FFH
       EXX
rhlp:
alp:   XOR  A
       CALL SW_CLR
       LD   A,(IY+0)
       SET  7,H
       CALL SW_CLR
       RES  7,H
       LD   DE,(TMP_W)
       ADD  HL,DE
       BIT  7,B
       EXX
       JR   Z,alp
       INC  IY
       DJNZ rhlp
       RET

;SWITCH PROC FOR SW_CLRL
FIL:   INC  C
       DEC  C
       RET  Z
       LD   (HL),A
       PUSH BC
       DEC  C
       JR   Z,frt
       PUSH HL
       LD   D,H
       LD   E,L
       INC  DE
fsh:   LD   B,0
       LDIR
       POP  HL
frt:   POP  BC
       RET

MOV:   INC  C
       DEC  C
       RET  Z
       PUSH BC
       PUSH HL
       EX   DE,HL
       LD   HL,(TMP_W)
       ADD  HL,HL
       ADD  HL,HL
       ADD  HL,HL
       ADD  HL,DE
       JR   fsh

;------------------------------------
;ROLL WINDOW UP
UROLL: LD   HL,-40
       LD   (TMP_W),HL
       LD   C,(IX+_W_X1)
       LD   B,(IX+_W_Y2)
       CALL EV_COR
       LD   DE,40*7
       ADD  HL,DE
       JR   rlsh

;ROLL WINDOW DOWN
ROLL?: BIT  _ROLL,(IX+_FLAG1)
       RET  NZ
ROLL:  LD   HL,40
       LD   (TMP_W),HL
       LD   BC,(W_X1)
       CALL EV_COR
rlsh:  PUSH HL
       LD   HL,(W_X2)
       LD   BC,(W_X1)
       OR   A
       SBC  HL,BC
       INC  L
       LD   B,H
       LD   C,L
       LD   HL,MOV
       LD   (SW_CLR+1),HL
       POP  HL
       BIT  _FASTR,(IX+_FLAG1)
       JR   Z,R_NOF
       LD   A,40
       BIT  _VMODE,(IX+_FLAG)
       JR   Z,RL_1
       ADD  A,A
RL_1:  CP   C
       JR   Z,F_ROLL
R_NOF: SLA  B
       SLA  B
       SLA  B
       PUSH BC
       CALL NZ,SW_CLL
       POP  BC
       JR   RL_2
F_ROLL:PUSH BC
       PUSH HL
       CALL Bx320
       LD   B,H
       LD   C,L
       POP  DE
       LD   HL,(TMP_W)
       ADD  HL,HL
       ADD  HL,HL
       ADD  HL,HL
       ADD  HL,DE
       LD   A,20H
       JR   FRL_EN
FRL_LP:POP  DE
       ADD  A,D
       LD   D,A
       LD   A,B
       XOR  40H
       BIT  _TRANS,(IX+_FLAG1)
       JR   Z,_FRS2_
       XOR  80H
_FRS2_:POP  BC
FRL_EN:PUSH BC
       PUSH DE
       PUSH HL
       LDIR
       POP  HL
       LD   B,A
       ADD  A,H
       LD   H,A
       LD   A,B
       JR   NC,FRL_LP
       ADD  A,D
       LD   D,A
       EX   DE,HL
       POP  BC
       POP  BC
       POP  BC
RL_2:  PUSH HL
       LD   HL,FIL
       LD   (SW_CLR+1),HL
       BIT  7,(IX+_TMP_W+1)
       LD   HL,40
       LD   (TMP_W),HL
       POP  HL
       JR   Z,cesw1
       LD   DE,-40*7
       ADD  HL,DE
       JR   cesw1

;--------------------------------
; WROLL PROCEDURE. DIRECTION: 0-UP, 1-DOWN, 2-RIGHT, 3-LEFT
WROLL: CALL HEX_CVT
       DB   6
       DB   4
       RET  C
       OR   A
       JP   Z,ROLL
       DEC  A
       JP   Z,UROLL                     ; A=1 - RIGHT, A=2 - LEFT
       RRA
       CALL C,PRP_INS                   ; PROC'S PRP_INS DON'T CHANGE CF
       LD   C,(IX+_W_X1)
       JR   C,ROL_W
       CALL PRP_DEL
       LD   C,(IX+_W_X2)
ROL_W: LD   B,(IX+_W_Y1)
       CALL EV_COR
       LD   A,(W_Y2)
       SUB  (IX+_W_Y1)
       RET  C
       INC  A
       LD   B,A
       LD   C,(IX+_W_X1)
ROL_LW:LD   A,(W_X2)
       SUB  C
       RET  C
       INC  A
       LD   C,A
       LD   IY,ARR_CO
       JP   SW_RRL

;-------------------------------
; INS/DEL CHAR PROCS
I_CH:  CALL PRP_INS
       JR   ROL_L
D_CH:  CALL PRP_DEL
       LD   C,(IX+_W_X2)
ROL_L: CALL EV_COR
       LD   C,(IX+_CUR_X)
       LD   B,1
       JR   ROL_LW

;--------------------------------
;CLEAR TO END OF SCREEN
CLREOL: LD   HL,40
       LD   (TMP_W),HL
       LD   HL,FIL
       LD   (SW_CLR+1),HL
       LD   HL,(SCR_AD)
       LD   A,(W_X2)
       SUB  (IX+_CUR_X)
       RET  C
       INC  A
       LD   C,A
cesw1: LD   B,8
       LD   IY,ARR_CO
       JP   SW_CLL

;HOME CURSOR
PHOME: call rom_chk
HOME:  LD   BC,0
       JP   GOXY

;RESET WHOLE SCREEN
CLRALL: LD   (IX+_W_X1),0
       LD   (IX+_W_X2),79
       LD   (IX+_W_Y1),0
       LD   (IX+_W_Y2),24
       BIT  _VMODE,(IX+_FLAG)
       JR   NZ,dsx
       LD   (IX+_W_X2),39
dsx:
CLRPG: CALL HOME

;CLEAR REST OF PAGE
CLR_EOP:
       CALL CLREOL
       LD   A,(W_Y2)
       SUB  (IX+_CUR_Y)
       RET  C
       RET  Z
       LD   B,A
       LD   A,(W_X2)
       SUB  (IX+_W_X1)
       INC  A
       LD   C,A
       PUSH BC
       LD   B,(IX+_CUR_Y)
       INC  B
       LD   C,(IX+_W_X1)
       CALL EV_COR
       POP  BC
cllp:  PUSH HL
       PUSH BC
       CALL cesw1
       POP  BC
       POP  HL
       LD   DE,320
       ADD  HL,DE
       DJNZ cllp
       RET

; OUT CHAR & ADVANCE POSITION
PUT_CH:
       CALL encode
_P_CHA: CALL _PUT_C
__pch: LD   A,(CUR_X)
       CP   (IX+_W_X2)
       JR   NC,n_pos
       INC  A
       LD   (CUR_X),A
       CALL ADV
       LD   (SCR_AD),HL
       RET
n_pos: LD   B,(IX+_CUR_Y)
       LD   C,(IX+_W_X1)
N_POS1: INC  B
       CALL _CHKCO
       PUSH BC
       CALL C,ROLL?
       POP  BC
_GOXY?: JP  _GOXY

;OUTPUT CHAR
OUT_CH: CP  " "
       JP   NC,PUT_CH
       LD   BC,(CUR_X)
       CALL HEX_CVT1
       DB   CCH_L*8
CCH_T: DEFB 0DH,0AH,0EH,0FH,1BH,7,8,9
CCH_L  EQU  $-CCH_T
       RET
       NOP
       JR   TAB_P
       JR   BS_P
       JR   BELL_P
       JR   ESC_P
       JR   DC1_P
       JR   DC3_P
       JR   N_POS1
CR_P:  LD   C,(IX+_W_X1)
       JR   _GOXY?

DC1_P: SET  _RUS,(IX+_FLAG)
       LD   HL,ENC_SI
dcsh:  LD   DE,SG_ENC
       LD   BC,4
       LDIR
       JP   RL_BRD

DC3_P: RES  _RUS,(IX+_FLAG)
       LD   HL,ENC_SO
       JR   dcsh

ESC_P: LD   HL,ELET_P
set_sw: LD   (OUT_SW+1),HL
       RET

TAB_P: LD   A," "
       CALL _P_CHA
       LD   A,(CUR_X)
       AND  7
       JR   NZ,TAB_P
       RET

BS_P:  DEC  C
       CALL _CHKCO
       JR   NC,_GOXY?
       LD   C,(IX+_W_X2)
       DEC  B
       CALL _CHKCO
       JR   NC,_GOXY?
       LD   B,(IX+_W_Y2)
       JR   _GOXY?

BELL_P: LD   HL,(BEEP_D)
BEEP:  LD   A,(BORDER)
       LD   C,(IX+_FE_IMG)
       DI
bplp:  LD   B,H
       OUT  (C),A
       DJNZ $
       XOR  10H
       DEC  L
       JR   NZ,bplp
       EI
       RET

;ESC SEQUINCE CONTROL ROUTINE
ELET_P: SUB  "@"
       JR   NC,tst_l
RES_OU: LD   HL,OUT_CH
       JR   set_sw
tst_l: CP   NPAR_L
       JR   NC,RES_OU
       INC  A
       LD   (FUNC),A
       DEC  A
       LD   HL,NPAR_T
       CALL ADD_HL_A
       LD   A,(HL)
       OR   A
       JR   Z,do_pr
ACP_1: LD   HL,PAR1
       LD   (FCNT),A
       LD   (PAR_PT),HL
       LD   HL,ACC_PA
       JR   set_sw

ACC_PA: LD   HL,(PAR_PT)
       SUB  ' '
       JR   NC,AP_OK
       LD   (IX+_FUNC),0FFh
AP_OK: LD   (HL),A
       INC  HL
       LD   (PAR_PT),HL
       DEC  (IX+_FCNT)
       RET  NZ
do_pr:
       LD   HL,OUT_CH
       LD   (OUT_SW+1),HL
       LD   B,0
       LD   C,(IX+_FUNC)
       INC  C
       RET  Z
       DEC  C
       LD   HL,JPAR_T
IJMP:  ADD  HL,BC
       ADD  HL,BC
       LD   C,(HL)
       INC  HL
       LD   B,(HL)
       PUSH BC
       LD   BC,(CUR_X)
       LD   A,(PAR1)
       RET

NPAR_T:DEFB 1, 0, 0, 0  ; @ABC
       DEFB 0, 0, 2, 0  ; DEFG
       DEFB 0, 0, 0, 0  ; HIJK
       DEFB 16,1, 1, 1  ; LMNO
       DEFB 0, 0, 9, 0  ; PQRS
       DEFB 0, 2, 0, 4  ; TUVW
       DEFB 1, 2, 1, 1  ; XYZ[
       DEFB 2, 2, 2, 0  ; \]^_
       DEFB 16,1, 2, 16 ; 'ab
NPAR_L EQU  $-NPAR_T

JPAR_T:DEFW SETP_AUX  ; SET PALLET EXECUTABLE PART
       DEFW PUT_CH, UP_P,   DN_P,   RT_P   ; @ABC
       DEFW LT_P,   CLRPG,  SET_CO, GRAPH  ; DEFG
       DEFW PHOME,  RLF_P,  CLR_EOP,CLREOL ; HIJK
       DEFW SET_CA, MODE,   PALLET, PLAY   ; LMNO
       DEFW I_CH,   D_CH,   SETENC, I_LIN  ; PQRS
       DEFW D_LIN,  BORD_P, GET_ALL,WIND   ; TUVW
       DEFW WROLL,  C_GOXY, S_CUR,  CUR_PAR; XYZ[
       DEFW KEY_PA, CUR_LN, SET_MOD,CLRALL ; \]^_
       DEFW SP_AUX, _CUR_PA,_KEY_PA,PRN_SC ; 'abc

UP_P:  DEC  B
       CALL _CHKCO
       JR   NC,GO
       LD   B,(IX+_W_Y2)
GO:    JP   _GOXY

DN_P:  INC  B
       CALL _CHKCO
       JR   NC,GO
       LD   B,(IX+_W_Y1)
       JR   GO

RT_P:  INC  C
       CALL _CHKCO
       JR   NC,GO
       LD   C,(IX+_W_X1)
       JR   GO

LT_P:  DEC  C
       CALL _CHKCO
       JR   NC,GO
       LD   C,(IX+_W_X2)
       JR   GO

RLF_P: INC  B
       DEC  B
       SCF
       JR   Z,RLF_SK
       DEC  B
       CALL _CHKCO
RLF_SK:PUSH BC
       CALL C,UROLL
       POP  BC
       JP   _GOXY

SET_CO: LD   DE,0
col_sw: LD   B,8
       PUSH IX
       LD   IX,ARR_CO
       LD   IY,PAR1
sclp:  PUSH DE
       PUSH BC
       CALL SW_SCO
       POP  BC
       POP  DE
       JR   C,SC_BRK
       ADD  IY,DE
       DJNZ sclp
SC_BRK: POP  IX
       RET

SET_CA: LD   DE,2
       JR   col_sw

;SET OF SW_SCO ROUTINE
SCO_H: LD   A,(IX+0)
       CALL UNPCK
       SRL  (IX+8)
       RR   B                   ; HI BIT IS INVERT
       SRL  (IX+8)
       RR   C
       LD   A,(IY+0)
       CALL HEX_CVT
       DB   1+4+2*8             ; MATCH 2 LETTER , UPCASE, HEX
       DB   'NI'                ; N- OLD VALUE, I - INVERT
       RET  C                   ; Number/error
       NOP
       LD   B,A                 ; Invert
       NOP
       LD   A,(IY+1)            ; Not change
       CALL HEX_CVT
       DB   1+4+2*8             ; MATCH 2 LETTER , UPCASE, HEX
       DB   'NI'
       RET  C                   ; Number/error
       NOP
       LD   C,A                 ; Invert
       NOP
       BIT  7,B                 ; Not change
       JR   Z,schs1
       LD   A,C
       CALL INVERT
       LD   B,A
       SET  0,(IX+8)
schs1: BIT  7,C
       JR   Z,schs2
       LD   A,B
       CALL INVERT
       LD   C,A
       SET  1,(IX+8)
schs2: CALL PCK
       LD   (IX+0),A
       INC  IX
       OR   A
       RET

SCO_M: LD   B,2
       LD   A,(IY+0)
scmlp: CALL HEX_CVT
       DB   1+4+3*8             ; UPCASE, HEX, 3 MATCH CHAR
       DB   'ONI'
       JR   scmt1
       JR   scmi1
       JR   scmn1
scmo1: SET  7,(IX+0)
       JR   scmn1
scmi1: SET  5,(IX+0)
       JR   scmn1
scmt1: RET  C
       ADD  A,0F8H
       XOR  0F8H
       AND  5FH
       LD   (IX+0),A
scmn1: INC  IX
       LD   A,(IY+1)
       DJNZ scmlp
       BIT  3,(IX-2)
       JR   Z,scms1
       LD   A,(IX-1)
       CALL INVERT
       ADD  A,0F8H
       AND  5FH
       XOR  78H
       LD   (IX-2),A
scms1: BIT  3,(IX-1)
       RET  Z
       LD   A,(IX-2)
       CALL INVERT
       ADD  A,0F8H
       AND  5FH
       XOR  78H
       LD   A,(IX-1)
       RET

;PACK & UNPACK ATTRIBUTE BYTE
UNPCK: LD   B,A        ;in A-COLOR
       RRA  ;out B-INK<<1, C-PAPER<<1
       RRA
       RRA
       LD   C,A
       AND  8
       XOR  B
       AND  0F8H
       XOR  B
       ADD  A,A
       LD   B,A
       LD   A,C
       RRA
       AND  8
       XOR  C
       AND  0F8H
       XOR  C
       ADD  A,A
       LD   C,A
       RET

PCK:   LD   A,B        ;in B-INK, C-PAPER
       XOR  C         ;out A-COLOR
       AND  0F8H
       XOR  C
       RL   C
       XOR  C
       AND  0EFH
       XOR  C
       RLA
       RLA
       RLA
       XOR  B
       AND  0F8H
       XOR  B
       RET

SET_MOD:CALL HEX_CVT
       DB   1+M_LNG*8
_M_S:  DB   'RBFTO'
M_LNG  EQU  $-_M_S
       NOP
       RET  C
       AND  7FH
       LD   B,A
       INC  B
       XOR  A
       SCF
SM_L:  RLA
       DJNZ SM_L
       LD   C,A
       LD   A,(PAR2)
       CALL HEX_CVT
       DB   6
       DB   2
       RET  C
       RRA
       SBC  A,A
       LD   B,(IX+_FLAG1)
       XOR  B
       AND  C
       XOR  B
       LD   (FLAG1),A
       RET

;MODE PROCEDURE
MODE:  BIT  0,(IX+_PAR1)
       LD   HL,ARR_CO
       JR   Z,md_m
       SET  5,(IX+_FE_IMG)
       SET  _VMODE,(IX+_FLAG)
       LD   DE,ARR_CO+1
       LD   BC,8
       LD   (HL),7
       LDIR
       LD   (HL),0
       LD   BC,7
       LDIR
       LD   HL,HI_MOD
md_sh: LD   DE,SW_C
       LD   BC,SW_SIZ
       LDIR
       CALL OUT_FE
       JP   CLRALL
md_m:  RES  5,(IX+_FE_IMG)
       RES  _VMODE,(IX+_FLAG)
       LD   B,8
md_m_l: LD   (HL),7
       INC  HL
       LD   (HL),0
       INC  HL
       DJNZ md_m_l
       LD   HL,M_MODE
       JR   md_sh

;BORDER & BORD COLOR MANIP ROUTINES
BORD_P:CALL HEX_CVT
       DB   4
       RET  C
       LD   C,A
       LD   A,(PAR2)
       CALL HEX_CVT
       DB   4
       RET  C
       RRCA
       RRCA
       RRCA
       RRCA
       XOR  C
       AND  0F0H
       XOR  C
       LD   (BCOL),A

RL_BRD: LD   A,(BCOL)
       BIT  _RUS,(IX+_FLAG)
       JR   NZ,SET_BR
       RRA
       RRA
       RRA
       RRA

SET_BR:LD   C,A
       XOR  (IX+_BORDER)
       AND  7
       XOR  (IX+_BORDER)
       LD   (BORDER),A
       LD   A,(FE_IMG)
       XOR  C
       AND  0F7H
       XOR  C
       XOR  8
       LD   (FE_IMG),A

OUT_FE:LD   C,(IX+_FE_IMG)
       LD   A,(BORDER)
       OUT  (C),A
       RET

;GOTOXY PROC
C_GOXY: LD  C,(IX+_PAR2)
       LD   B,A
       JP   GOXY

;WINDOW PROC
WIND:  LD   A,(PAR3)
       CP   (IX+_PAR1)
       RET  C
       LD   L,A
       BIT  _VMODE,(IX+_FLAG)
       JR   NZ,$+4
       ADD  A,A
       RET  C
       CP   80
       RET  NC
       LD   A,(PAR4)
       CP   (IX+_PAR2)
       RET  C
       CP   25
       RET  NC
       LD   H,A
       LD   (W_X2),HL
       LD   HL,(PAR1)
       LD   (W_X1),HL
       JP   HOME

I_LIN: LD   HL,UROLL
id_lin:LD   A,(W_Y1)
       PUSH AF
       LD   (IX+_W_Y1),B
       CALL id__1
       POP  AF
       LD   (W_Y1),A
       RET
id__1: JP   (HL)

D_LIN: LD   HL,ROLL
       JR   id_lin

S_CUR: CALL HEX_CVT
       DB   6
       DB   3
       RET  C
       RES  _FLEX_C,(IX+_FLAG)
       DEC  A
       JP   Z,CUR_AC
       INC  A
       EX   AF,AF'
       CALL CUR_PA
       EX   AF,AF'
       RET  Z
       SET  _FLEX_C,(IX+_FLAG)
       RET

CUR_PAR:CALL HEX_CVT
       DB   1+6
       DB   32
       RET  C
       CALL LOG
_CUR_PA:LD  (C_MAX),A
       RET

_KEY_PA:LD  (KEY_REP),A
       LD   A,(PAR2)
       JR   _KP_1
KEY_PA:CALL HEX_CVT
       DB   1+6
       DB   32
       RET  C
       CALL LOG
       LD   (KEY_REP),A
       LD   A,(PAR2)
       CALL HEX_CVT
       DB   1+6
       DB   32
       RET  C
       CALL LOG
_KP_1: ADD  A,A
       DEC  A
       LD   (KEY_DEL),A
       RET

LOG:   INC  A
       CP   16
       RET  C
       SUB  8
       CP   16
       JR   C,LOG1
       SUB  8
       ADD  A,A
LOG1:  ADD  A,A
       RET

CUR_LN:CALL HEX_CVT
       DB   6
       DB   8
       RET  C
       LD   B,A
       LD   A,(PAR2)
       CALL HEX_CVT
       DB   6
       DB   8
       RET  C
       CP   B
       RET  C
       INC  A
       LD   (IX+_C_BEG),B
       LD   (C_END),A
       RET

SETENC:CALL HEX_CVT
       DB   6
       DB   3
       RET  C
       ADD  A,A
       LD   HL,SG_ENC
       CALL ADD_HL_2A
       LD   DE,PAR2
       LD   B,8
SEC_LP:LD   A,(DE)
       INC  DE
       CALL HEX_CVT
       DB   4
       RET  C
       RLD
       BIT  0,B
       JR   Z,SEC_1
       INC  HL
SEC_1: DJNZ SEC_LP
MY_RET:RET

PRN_SC:LD   DE,PAR1
       LD   HL,ED_BUF
       LD   B,16
       CALL SEC_LP
       LD   DE,ED_BUF
       CALL _pt_ch
       JP   __pch

PALLET:CALL HEX_CVT
       DB   1+4+8*2
       DB   'RT'
       NOP
       RET  C
       CP   81H
       JR   Z,SP_DEF
       LD   (PAR4),A
       XOR  A
       LD   (FUNC),A
SPA_s: LD   A,3
       JP   ACP_1

SP_DEF:LD   HL,PALN
       JR   SP_AUX1

SP_AUX:LD   HL,PAR1
SP_AUX1:LD   DE,PAL_BUF
       LD   BC,16
       LDIR
       JR   SET_PAL

SETP_AUX:
       LD   B,3
       LD   D,0
       LD   HL,PAR1
PACC_: LD   A,(HL)
       CALL HEX_CVT
       DB   6
       DB   4
       RET  C
       CPL
       RRA
       RRA
       RL   D
       RLA
       SBC  A,A
       AND  8
       OR   D
       LD   D,A
       INC  HL
       DJNZ PACC_
       LD   HL,PAL_BUF
       LD   A,(PAR4)
       AND  7FH
       CALL ADD_HL_A
       LD   (HL),D                      ; page 1 sets on entry to conout
       INC  (IX+_PAR4)
       JP   P,SET_PAL
       BIT  4,(IX+_PAR4)
       JR   Z,SPA_s
;----------------------
; SET PALLET FROM PAL_BUF
SET_PAL: DI
       LD   A,I
       PUSH AF
       LD   A,HIGH(MY_R_ADR)           ; 3dh
       LD   I,A
       IM   2
       LD   A,(BORDER)
       AND  0F8H
       LD   HL,PAL_BUF
       LD   BC,7DFDH
       LD   D,8
       EXX
       LD   C,(IX+_FE_IMG)
       SET  3,C
       EXX
       EI
       HALT
SPL:   EXX
       OUT  (C),A
       EXX
       OUTI
       INC  B
       INC  A
       DEC  D
       JR   NZ,SPL
       EXX
       RES  3,C
       EXX
       SUB  8
       LD   D,8
SPL1:  EXX
       OUT  (C),A
       EXX
       OUTI
       INC  B
       INC  A
       DEC  D
       JR   NZ,SPL1
       POP  AF
       LD   I,A
       IM   1
       EI
       LD   BC,1000H                   ; FIND MIN&MAX COLORS
       LD   DE,0FFH                    ; D - max, E - min
       LD   HL,PAL_BUF
FIV_LP:CALL CLT
       CP   D
       JR   C,FIV_NU
       LD   D,A
       LD   (IX+_I_MAX),C
FIV_NU:CP   E
       JR   NC,FIV_ND
       LD   E,A
       LD   (IX+_I_MIN),C
FIV_ND:INC  C
       INC  HL
       DJNZ FIV_LP
       LD   A,D
       ADD  A,E
       LD   (I_AVR),A
       JP   RL_BRD

;------------------------------------------------
; ROLL RIGHT/LEFT ROUTINE
SW_LINE: PUSH BC
       LD   B,C
       LD   C,A
       LD   D,A
       PUSH HL
SWL_L: LD   A,(HL)
       LD   (HL),C
       LD   C,A
       CALL ED_BUF                      ; INC/DEC SUBROUTINE THERE
       DJNZ SWL_L
       POP  HL
       POP  BC
       LD   A,D
       RET

;------------------------------------------------
; PREPARE FOR INSERT/DELETE CHARS (DON'T CHANGE CF!)
PRP_INS: LD L,23H                       ; INC HL
       LD   DE,ADV2
       JR   PRP_
PRP_DEL: LD L,2BH                       ; DEC HL
       LD   DE,DEG2
PRP_:  BIT  _VMODE,(IX+_FLAG)
       JR   Z,PR_M
       LD   A,0C3H                      ; JP
       LD   (ED_BUF),A
       LD   (ED_BUF+1),DE
       JR   PRP_1
PR_M:  LD   H,0C9H                      ; RET
       LD   (ED_BUF),HL
PRP_1: LD   HL,40
       LD   (TMP_W),HL
       LD   HL,SW_LINE
       LD   (SW_CLR+1),HL
       RET

DEG2:  LD   A,20H
       XOR  H
       LD   H,A
       AND  20H
       RET  Z
       DEC  HL
       RET

INVERT:PUSH HL
       LD   HL,PAL_BUF
       CALL ADD_HL_A
       CALL CLT
       ADD  A,A
       LD   HL,I_AVR
       CP   (HL)
       POP  HL
       LD   A,(I_MIN)
       RET  NC
       LD   A,(I_MAX)
       RET

CLT:   PUSH HL
       PUSH BC
       LD   C,(HL)
       LD   HL,CLT_TB
       LD   B,6
       XOR  A
CLT_LP:RR   C
       JR   C,CLT_1
       ADD  A,(HL)
CLT_1: INC  HL
       DJNZ CLT_LP
       POP  BC
       POP  HL
       RET

CLT_TB:DB   2,6,0CH,1,3,6

;------------------------------------------------
CONOUT: PUSH BC       ;PRINT CHAR FROM A
       PUSH DE       ;DESTROY ALL ALT REGS
       PUSH HL       ;IX MAST POINT TO IX_BASE
       PUSH IY
       PUSH AF
       EX   AF,AF'
       LD   A,1
       RST  18H
       PUSH AF
       CALL CUR_PA
       EI
       EX   AF,AF'
       CALL OUT_SW
       CALL CUR_AC
       POP  AF
       RST  18H
       EI
       POP  AF
       POP  IY
       POP  HL
       POP  DE
       POP  BC
       RET
