.z80
INCLUDE DEFINES.INC
BIOS    EQU     0EA00H
CCP     EQU     BIOS-1600H

PRINT   MACRO   A1,A2,A3,A4,A5
IF1
.PRINTX /A1 A2 A3 A4 A5/
ENDIF
        ENDM

DM     MACRO name, size, com
IF     GEN_MRK
_&name EQU $-IX_BAS
name:  DEFS size
ELSE
 IFNB <com>
       com
 ENDIF
ENDIF
       ENDM

;   conio
        cseg
	ORG    0
        DI
	JP     ENTRY

	ORG	8H
	JP	RST8

	ORG	10H
	JP	RST10

	ORG	18H
	JP	SET_PG

;	ORG	20H
;	JP	RST20

;	ORG	28H
;	JP	RST28

;	ORG	30H
;	JP	RST30

	ORG    38H
	JP     DO_INT

SG_BEG:
.XLIST
INCLUDE SGIMG.MAC
.LIST

INCLUDE CONIO.MAC

INCLUDE HEX.MAC

INCLUDE SCANKEY.MAC

; CONVERT PAGE NUMBER
ED_PG:  ADD     A,6+RU5
IF RU7
        CP      0CH
        RET     C
        INC     A
ENDIF
        RET

; SET PAGE NUMBER
SET_PG: DI
        LD      B,(IX+_MEMDSP)
        LD      (MEMDSP),A
S_PG1:  PUSH    BC
        PUSH    AF
        RRA
        RRA
        RRA
        XOR     (IX+_SYS_P)
        AND     3
        XOR     (IX+_SYS_P)
        LD      BC,0FDFDH
        OUT     (C),A
        POP     AF
        AND     7
        OR      10H
        LD      BC,7FFDH
        OUT     (C),A
        POP     AF
        RET

ENTRY:  LD      SP,SYS_SP       ; MUST BE CPSYS
        IM      1

        JR      ALL_INIT        ; HOOK TEST !!!!!!!!!!!
.comment @
IF ROM
	XOR	A
	OUT	(0BEH),A
	IN	A,(0FEH)
	OR	0E0H
	INC	A
	JR	NZ,ALL_INIT
ELSE
        OR      A
ENDIF
        LD      HL,(TST_SIG)
	LD	DE,55AAH
	SBC	HL,DE
	JR	NZ,ALL_INIT

	LD	A,3
	CALL	S_PG1
	LD	HL,0F800H
	LD	BC,16
	LD	A,0C3H
M_TST:	CPI		    ; TEST FOR MONITOR PRESENTS
	JR	NZ,ALL_INIT
	INC	HL
	INC	HL
	JP	PE,M_TST
C_TST:	XOR	A	    ; TEST FOR CPM INTEGRITY
	CALL	S_PG1
	LD	A,(0)
	CP	0C3H
	JR	NZ,CPM_RINI
	LD	A,(5)
	CP	0C3H
	JR	NZ,CPM_RINI
	LD	A,(FE_IMG)
	LD	C,A
	LD	A,(BORDER)
	OUT	(C),A
	JP	ENTR2       ; RESTART
@
ALL_INIT: LD      A,1
        CALL    C_INIT
	CALL    M_INIT
IF ROM
	LD      A,1
        CALL    C_INIT
	CALL	M_INIT
CPM_RINI: LD    SP,0B000H
        LD      HL,PR1          ; MENU THERE
        LD      DE,8000H
        LD      BC,PR1_S
        LDIR
        XOR     A
        RST     18H
        LD      DE,0C000H
        LD      BC,3C10H
        CALL    8000H
        LD      A,3
        RST     18H
        LD      HL,0
        LD      (ENT_ADR),HL
        CALL    ENTR2
	push	af
        LD   HL,PALN
        CALL SP_AUX1
        pop     af
	LD	D,A
	OR	A
	JR	Z,GOCPM
	XOR	A
	OUT	(0FEH),A
        DEC     D
        JP      Z,TR_RUN
        DEC     D
        JR      Z,BAS128
	LD	A,3
	CALL	S_PG1
        JR      BASGO
GOCPM:  LD      A,1
        LD      SP,SYS_SP
        CALL    C_INIT
        CALL    CPM_LOAD
        JP      par_init

BAS128: LD      A,3
        CALL    S_PG1
        LD      BC,7FFDH
        LD      A,3
        OUT     (C),A
BASGO:  LD      HL,40EDH
        LD      (0FFFEH),HL
        LD      BC,0FF7BH
        JP      0FFFEH

PR1:
.PHASE 8000H
        IN      A,(7BH)
        CALL    __1            ; 3C10 - MOVE IMAGE
        IN      A,(0FBH)
        RET
TR_RUN: IN      A,(7BH)
        LD      BC,7FFDH
	LD	A,30H
	OUT	(C),A
        LD      BC,0
__1:	PUSH	BC
	JP	3D2DH
.DEPHASE
PR1_S   EQU     $-PR1
ELSE
CPM_RINI: CALL    CPM_LOAD
ENDIF

par_init: ld    a,1
        rst     18h
        ei
        call    _pinit_
        ld      a,3
        rst     18h
        jp      entr1

_pinit_:ld      hl,0ff40h
        push    hl
        ld      b,192
        xor     a
pin_lp: add     a,(hl)
        adc     a,0
        djnz    pin_lp
        dec     a
        pop     hl
        push    af
        jr      z,_pinit
        ld      hl,def_run
_pinit: ld      c,(hl)
        inc     c
        ld      b,0
        ld      de,CCP+7
        rst     8
        db      0feh, 1
        pop     af
        ret     nz
pin_l1: ld      a,(hl)
        inc     hl
        or      a
        ret     z
        call    conout
        jr      pin_l1
def_run: db 5,'B:XC /R'

DO_INT: PUSH AF
       IN   A,(0FFH)
       PUSH AF                 ; TEST TRDOS ACTIVITY
       PUSH BC
       PUSH DE
       PUSH HL
       EX   AF,AF'
       EXX
       PUSH AF
       PUSH BC
       PUSH DE
       PUSH HL
       PUSH IX
       LD   IX,IX_BAS
       LD   A,1
       RST  18H
       PUSH AF
       CALL RRET
       LD   HL,TIME_C
       LD   B,4
TM_L:  INC  (HL)
       INC  HL
       JR   NZ,TM_DN
       DJNZ TM_L
TM_DN: CALL CUR_IN
       POP  AF
       RST  18H
       CALL keyboard
       POP  IX
       POP  HL
       POP  DE
       POP  BC
       POP  AF
       EXX
       EX   AF,AF'
       POP  HL
       POP  DE
       POP  BC
       POP  AF
       INC  A
       CALL NZ,RET_ROM
       POP  AF
       EI
       RET

;---------------------------
; MULTYPLEXOR CALL
;
DO_MUX: EI
	PUSH HL
        PUSH DE
	PUSH AF
	LD   A,MUX_LNG-1
	CP   C
	JR   NC,MUX_OK
	POP  AF
	LD   A,0FFH
        POP  DE
	POP  HL
	RET
MUX_OK: LD   A,C
	LD   HL,MUX_TBL
        CALL _IND
	POP  AF
        POP  DE
	EX   (SP),HL
	RET

MUX_TBL: DW R_VER, CPM_L, SET_RST ; func 0,1,2
         DW read_knw           ; (3) read key (no wait) (see scankey)
         DW kb_typ             ; (4) read keyb type (L) & flags (D)
         DW g_time             ; (5) get current time
         DW wr_fe              ; (6) write to 'FE' port
         DW adr_fe             ; (7) get address & default of 'FE' port
         DW wr_sys             ; (8) write to SYS port ('ton' & 'tnab' bits)
         DW adr_sys            ; (9) get address & default of SYS port
         ;!!!!!!!!!!!!!!!!!!!!!!!
;         dw TST_RT     ; ret HL & RTIME
;         dw SIGN       ; D - const
                        ; ret - HL
         ;!!!!!!!!!!!!!!!!!!!!!!!
MUX_LNG  EQU ($-MUX_TBL)/2


R_VER:  LD      HL,104h ; MUX FUNC 0 - GET VERSION (HL-VERSION)
	XOR	A
	RET

CPM_L:  LD	BC,1600H; MUX FUNC 1 - LOAD CPM IMAGE
	CALL	CPM_L1
	XOR	A
	RET

SET_RST:LD      DE,(ENT_ADR)    ; MUX FUNC 2 - SET RESTART ADRESS
        LD      (ENT_ADR),HL    ; HL - ADRESS FOR RESTART (RET in HL old)
        EX      DE,HL
	XOR	A
	RET

g_time: ld      de,(TIME_C)     ; MUX FUNC 5 - get time into hl:de
        ld      hl,(TIME_C+2)
        xor     a
        ret

wr_fe:  ex      af,af'          ; MUX FUNC 6 - write to 'FE' port
        ld      a,(BORDER)      ; in A-value
        ex      af,af'          ; out A'-old value, C-port addr
        ld      c,(ix+_FE_IMG)
        xor     (ix+_BORDER)
        and     not 7
        xor     (ix+_BORDER)
        out     (c),a
        ld      (BORDER),a
        set     7,c
        xor     a
        ret

adr_fe: ld      c,(ix+_FE_IMG)  ; MUX FUNC 7 - get address & default of 'FE' port
        ld      a,(BORDER)      ; in - none
        ex      af,af'          ; out A'-old value, C-port addr
        set     7,c
        xor     a
        ret


wr_sys: ld      bc,0fdfdh       ; MUX FUNC 8 - write to SYS port ('ton' & 'tnab' bits)
        ex      af,af'          ; in A-value
        ld      a,(SYS_P)       ; out A'-old value, BC-port addr
        ex      af,af'
        xor     (ix+_SYS_P)
        and     0f8h
        xor     (ix+_SYS_P)
        out     (c),a
        ld      (SYS_P),a
        xor     a
        ret

adr_sys:ld      bc,0fdfdh       ; MUX FUNC 9 - get address & default of SYS port
        ld      a,(SYS_P)
        ex      af,af'
        xor     a
        ret


;   dmon
INCLUDE DDEF.MAC

        cseg
INCLUDE DISK.MAC

;   drv
FDC_DRV:

INCLUDE FDC_WD.MAC

ED_DRV:

INCLUDE ED_DRV.MAC

;   init
VAR1_I:
.8080
GEN_MRK SET 0
.Z80
.XLIST
INCLUDE VAR1.MAC
.LIST

VAR1_S     EQU      $-VAR1_I

INCLUDE INIT.MAC

IF RU7
CH1:            ; Edisk  RU7
        DB      0FFH    ;+  
        DB      2       ;+  
        DB      0       ;+  
        DB      1       ;-  
        DB      1       ;+   
        DB      0       ;+   
        DW      1AH     ;+    
        DB      128     ;+    
        DW      128     ;+    
        DB      1       ;+   
        DW      0       ;+   
        DW      3328    ;+    
        DW      128     ;+    
        DW      1AH     ;+    
        DB      8       ;+     
        DW      128     ;+    
        DS      6
        DB      0
ENDIF
IF RU5
CH1:            ; Edisk RU5
        DB      0FFH    ;+  
        DB      2       ;+  
        DB      0       ;+  
        DB      1       ;-  
        DB      1       ;+   
        DB      0       ;+   
        DW      2       ;+    
        DB      128     ;+    
        DW      128     ;+    
        DB      1       ;+   
        DW      0       ;+   
        DW      256     ;+    
        DW      128     ;+    
        DW      2       ;+    
        DB      8       ;+     
        DW      128     ;+    
        DS      6
        DB      0
ENDIF
IF ROM
CH1:            ; Edisk RU7 (ROM)
        DB      0FFH    ;+  
        DB      2       ;+  
        DB      0       ;+  
        DB      1       ;-  
        DB      1       ;+   
        DB      0       ;+   
        DW      1BH     ;+    
        DB      128     ;+    
        DW      128     ;+    
        DB      1       ;+   
        DW      0       ;+   
        DW      3456    ;+    
        DW      128     ;+    
        DW      1BH     ;+    
        DB      8       ;+     
        DW      128     ;+    
        DS      6
        DB      0

CH1?5:          ; Edisk RU5 (ROM)
        DB      0FFH    ;+  
        DB      2       ;+  
        DB      0       ;+  
        DB      1       ;-  
        DB      1       ;+   
        DB      0       ;+   
        DW      3H      ;+    
        DB      128     ;+    
        DW      128     ;+    
        DB      1       ;+   
        DW      0       ;+   
        DW      384     ;+    
        DW      128     ;+    
        DW      3H      ;+    
        DB      8       ;+     
        DW      128     ;+    
        DS      6
        DB      0
ENDIF

       aseg
       ORG  5F40H
.8080
GEN_MRK SET 1
.Z80
IX_BAS:
INCLUDE VAR1.MAC

INCLUDE DVAR1.MAC

PRINT <LO.VAR1 FREE (STACK SIZE) - > %(6000H-$)

SYS_SP EQU  6000H

       aseg
       ORG  7F40H
ED_BUF: DS  128
MAXQUI EQU  10H; KEYBUFFER SIZE
BEGQUI: DS  MAXQUI

PRINT <LO.VAR2 FREE - > %(8000H-$)

       aseg
       ORG  0DF40H
INCLUDE VAR2.MAC

PRINT <HI.VAR1 FREE - > %(0E000H-$)

; Interface to rom bios

       cseg
MON_IMG:

.PHASE 0F800H
@RUN:   JP  RUN              ; Main menu of loader
@CI:    JP  CI               ; Consol in
@RI:    JP  RI               ; Reader in
@CO:    JP  CO               ; Consol out
@PO:    JP  POUT             ; Punch out
@LO:    JP  LOUT             ; List out
@CSTS:  JP  CSTS             ; Consol status
@IOCHK: JP  IOCHK            ; Get IO state
@IOSET: JP  IOSET            ; Set IO state
@MEMCK: JP  MEMCK            ; Get top of ram
@IODEF: JP  RET_RAM          ; Set user IO
@REST:  JP  IRUN             ; Interrupt entry
@RQDIO: JP  RQDIO            ; Call to disk monitor
@RQRES: JP  RQRES            ; Buffer reset
@RQSET: JP  RQSET            ; Chanall assign
@RQCHK: JP  RQCHK            ; Get chanall description block
@MUX:   JP  MUX

; temporary
RI:
POUT:

RET_RAM: NOP
         RET

RUN:    CALL S_ON
	JP   ALL_INIT
IRUN:	CALL S_ON
	RST  0

MUX:    CALL    SYS_ON
	CALL	DO_MUX
	CALL	SYS_OFF
	EI
	RET

IF rom
lport   equ     0fbh
ELSE
lport   equ     7bh
ENDIF

LOUT:   IN A,(lport)
	RLCA
	JR C,LOUT
	LD A,C
	OUT (0FBH),A
	OUT (07BH),A
	OUT (0FBH),A
	RET

MEMCK:  LD      B,0F8H
        LD      A,0
        RET

ENTR1:  CALL    S_OFF
        IM      2
        JP      BIOS

ENTR2:  CALL    S_OFF
        IM      2
	call    BIOS+3
ENT_ADR EQU 	$-2
        CALL    S_ON
        IM      1
        RET

;----------------------
RQRES:  CALL    SYS_ON
        LD      (IX+_BUFT),0FFH
        CALL    SYS_OFF
        EI
        RET
;-----------------------
RQSET:  LD      A,_SETCH
        JR      SETCHK
;-----------------------
RQCHK:  LD      A,_GETCH
SETCHK: CALL    SYS_ON
        CALL    PSCHK

;        EI
;        LD      (RQCOM),A
;        LD      (IX+_RQCHAN),C
;        PUSH    DE
;        PUSH    HL
;        EX      DE,HL
;        LD      (RQBADR),HL
;        LD      DE,RQCHAN
;        CALL    DISK
;        POP     HL
;        POP     DE

        CALL    SYS_OFF
        EI
        RET

;----------------------
RQDIO:  CALL    SYS_ON
        CALL    PDISK

;        LD      HL,RQCHAN
;        LD      (HL),C
;        LD      B,8
;        EX      DE,HL
;rqlp:   INC     HL
;        INC     DE
;        CALL    MOVAM
;        LD      (DE),A
;        DJNZ    rqlp
;        EI
;        CALL    DISK

        CALL    SYS_OFF
        EI
        RET

;----------------------
CO:     CALL    SYS_ON
        EI
        PUSH    AF
        LD      A,C
        CALL    CONOUT
        POP     AF
        CALL    SYS_OFF
        EI
        RET

;----------------------
CI:     CALL    SYS_ON
        EI
        CALL    READ_K
        CALL    SYS_OFF
        EI
        RET

;----------------------
CSTS:   CALL    SYS_ON
        CALL    STAT_K
        CALL    SYS_OFF
        EI
        RET

;----------------------
;  /
IOSET:  LD      A,C
        LD      (IOBYTE),A
        RET
;----------------------
;  /
IOCHK:  LD      A,(IOBYTE)
        RET

;----------------------
;RQMOV:  CALL    S_OFF

;LLLL:  LD      A,0FEH
;       IN      A,(0FEH)
;       AND     1
;       JR      NZ,LLLL

;        LDIR
;        CALL    S_ON
;        EI
;        RET

;RQGET:  LD      A,(HL)
;        EX      DE,HL
;        CALL    MOVMA
;        EX      DE,HL
;        INC     HL
;        INC     DE
;        DJNZ    RQGET
;        EI
;        RET

;RQPUT:  CALL    MOVAM
;        LD      (DE),A
;        INC     HL
;        INC     DE
;        DJNZ    RQPUT
;        EI
;        RET

;----------------------
;    
;MOVAM:  CALL    S_OFF
;        LD      A,(HL)
;        CALL    S_ON
;        RET

;MOVMA:  CALL    S_OFF
;        LD      (HL),A
;        CALL    S_ON
;        RET

;----------------------
;System on/off proc's
S_ON:   DI
        EX      (SP),HL
        LD      (R_ADR),HL
        POP     HL
        LD      (RA_I),A
        LD      A,C
        LD      (RC_I),A
        LD      C,0
FE_CPY  EQU     $-1
        SET     7,C
        LD      A,0
BOR_CPY EQU     $-1
        OUT     (C),A
sys_sw: LD      A,0
RA_I    EQU     $-1
        LD      C,0
RC_I    EQU     $-1
        JP      0
R_ADR   EQU     $-2

SYS_ON: DI
        EX      (SP),HL
        LD      (R_1),HL
        POP     HL
        CALL    S_ON
        LD      (OLD_SP),SP
        LD      SP,SYS_SP
        IM      1
        PUSH    IX
        LD      IX,IX_BAS
        JP      0
R_1     EQU     $-2

S_OFF:  DI
        EX      (SP),HL
        LD      (R_ADR),HL
        POP     HL
        LD      (RA_I),A
        LD      A,C
        LD      (RC_I),A
        LD      A,(FE_IMG)
        LD      (FE_CPY),A
        RES     7,A
        LD      C,A
        LD      A,(BORDER)
        LD      (BOR_CPY),A
        OUT     (C),A
        JR      sys_sw

SYS_OFF: DI
        EX      (SP),HL
        LD      (R_2),HL
        POP     HL
        POP     IX
        CALL    S_OFF
        LD      SP,(OLD_SP)
        IM      2
        JP      0
R_2     EQU     $-2

INT_R:
        LD      (OLD_SP),SP
        LD      SP,SYS_SP
        IM      1
        LD      (I_A_I),A
        LD      A,C
        LD      (I_C_I),A
        LD      A,(FE_CPY)
        SET     7,A
        LD      C,A
        LD      A,(BOR_CPY)
        OUT     (C),A
        CALL    DO_INT
        LD      A,(FE_IMG)
        LD      (FE_CPY),A
        RES     7,A
        LD      C,A
        LD      A,(BORDER)
        LD      (BOR_CPY),A
        OUT     (C),A
        LD      A,0
I_A_I   EQU     $-1
        LD      C,0
I_C_I   EQU     $-1
        DI
        LD      SP,(OLD_SP)
        IM      2
        EI
        RET

CHTBL:  DW      CH0          ; Chanall descriptions
        DW      CH1
        DW      CH2
        DW      CH3
        DW      CH4
        DW      CH5
        DW      CH6
        DW      CH7
        DW      CH8
        DW      CH9

;-----------------------
; 
DCTBL:: DW      0       ;
        DW      0       ;PD1207
        DW      ED_DRV
        DW      FDC_DRV
        DW      0       ;WD1207
        DW      0       ;
        DW      0       ;
        DW      0       ;
;-----------------------

OLD_SP: DS      2

QQ      EQU     $

        DEFS    (256*HIGH($+255))-$-1

PRINT <Idle space > %($-QQ)

INTRADR: DW     INT_R

;-----------------------
;   80X2
CH0:    DB      0FFH    ; 
        DB      3       ; 
        DB      0       ; 
        DB      0       ;    
        DB      0       ;  
        DB      2       ;  
        DW      80      ;   
        DB      16      ;   
        DW      256     ;   
        DB      2       ;  
        DW      0       ;  
        DW      5120    ;   
        DW      32      ;   
        DW      160     ;   
        DB      8       ;    
        DW      128     ;   
        DB      2       ;  
        DB      2       ;  
        DB      2       ;   
        DB      0       ;  
        DB      0       ; 8- 
        DB      0FFh    ; 
        DB      1       ; 
        DB      80      ;GAP3  /
        DB      80      ;GAP3  
        DB      0    ; 
        DB      0       ;  
        DB      0       ;  

MON_SIZE EQU    $-@RUN

CH2     EQU     $
CH3     EQU     CH2+23H
CH4     EQU     CH3+23H
CH5     EQU     CH4+23H
CH6     EQU     CH5+23H
CH7     EQU     CH6+23H
CH8     EQU     CH7+23H
CH9     EQU     CH8+23H

BUF     EQU     CH9+23H      ; Dmon buffer (1024 byte)
NXT     EQU     BUF+1024

PRINT <Monitor image size - > %(MON_SIZE)
PRINT <Total ram-resident part of rbios - > %(NXT-@RUN)
PRINT <FREE RAM (FROM TOP) - > %(0FFFFH-NXT+1)
.DEPHASE

GET_ALL:
GRAPH:
PLAY:
        ret

CPM_IMG:
.XLIST
INCLUDE BS.MAC
.LIST

CPM_SIZE EQU $-CPM_IMG
_MM1	EQU	$

	ORG	3DFDH
PRINT  <ROM LEFT - > %($-_MM1)

RET_ROM: NOP            ; 3DFD
        RET             ; 3DFE
        ORG  3DFFH
MY_R_ADR: DEFW  MY_RET

_MM	EQU	$
	ORG	4000H

PRINT <FREE ROM (FROM TOP) - > %($-_MM)

end

