.z80
key_scan: xor a
          in a,(0feh)
          or 0e0h
          inc a
          ret z
          LD L,-8                            ;initial key value
          LD DE,0                            ;initialise DE - no key, no shifts
          LD BC,0FEFEH                       ;C-port adress, D-counter
key_line: IN A,(C)                           ;read keyboard
          CPL
          AND 1FH                            ;mask for responce bits
          JR Z,key_done                      ;if no key pressed - down
          LD H,A                             ;hold value to H
          LD A,L                             ;restore initial key value
lp2:      add A,8H                           ;repeatedly subtract 8 from
          SRL H                              ;the presents key value until a
          JR NC,lp2                          ;key-bit is found
          or a
          jr nz,no_CS
          set _K_CS,e
          jr no_dn
no_CS:    cp 0fh
          jr nz,no_SS
          set _K_SS,e
          jr no_dn
no_SS:    ld d,a
no_dn:    inc h
          dec h
          JR NZ,lp2                          ;If more the one key pressed - pass back
key_done: inc L                              ;key value adjust for next scanning line
          RLC B                              ;next keyboard line
          JR C,key_line                      ;repeat for all lines
          LD A,D                             ;first key value
          or e
          RET

k_sta:  db 40h, 80h

k_st1:  db 3,4,0bh,0ch,13h,14h,1bh,1ch,23h,24h  ; CS
k_st1s  equ $-k_st1

k_st2:  db 4,5,8,0ch,0dh,0eh,10h,14h,16h,17h,18h,1eh,1fh,20h,26h,27h ; SS
k_st2s  equ $-k_st2
k_stas  equ $-k_sta

keyboard:: dec (ix+_k_5cnt)
        ret p
        ld  (ix+_k_5cnt),0
        call key_scan
        cp  (ix+_k_last)
        jr  z,k_old
;----- testing for unbalanced extend key
        ld  b,(ix+_k_buf)
        ld  (ix+_k_buf),-1
        inc b
        ld  d,a                       ; save for later
        ld  c,3fh
        jr  z,k_nobuf
        dec b
        and c                         ; key in buf
        jr  z,k_ored
        xor b
        and c
        jr  z,k_ored
        ld  a,b
        and c
        jr  z,k_ored
        ld  a,b
        and 0c0h
        or  c
        jr  k_sbuf
k_ored: ld  a,b
        or  d
        jr  k_nxt
k_nobuf:ld  a,(flag)                  ; mask already seted shift's bit
        cpl
        or  c                         ; c still 3fh
        and d
        ld  hl,k_sta                  ; it's may be unbalanced extend key?
        ld  bc,k_stas
        cpir
        ld  a,d
        jr  nz,k_nxt                  ; no - process it in order case
k_sbuf: ld  (k_buf),a                 ; else - remember it & process later
        ret
;----- end of test
k_nxt:  ld  b,a
        ld  a,(key_del)
        ld  (k_cnt),a
        ld  (ix+_k_5cnt),5
        ld  a,b
        and 3fh
        jr  z,k_stat                  ; no key (only shift)- set status
        xor (ix+_k_last)
        and 3fh                       ; key the same?
        jr  nz,k_done1                ; no (just pressed) - don't change stat
k_stat: ld  a,(flag)                  ; else set it
        xor b
        and 3fh
        xor b
        ld  (flag),a
k_done1:ld  (ix+_k_last),b
        jr  k_done
k_old:  bit 7,(ix+_k_cnt)
        ret nz
        dec (ix+_k_cnt)
        ret nz
        ld  a,(key_rep)
        ld  (k_cnt),a
k_done: ld  a,(flag)
        and 0c0h
        xor (ix+_k_last)
        jp p,ke_noh
        ld hl,k_st1
        ld c,k_st1s
        ld d,40
        jr k_1
ke_noh: bit _K_SS,a
        jr  z,k_put
        ld  d,40+k_st1s
        ld  hl,k_st2
        ld  c,k_st2s
k_1:    ld  b,0
        and 3fh
        cpir
        jr  nz,k_put
        ld  a,d
        add a,c
k_put:  or  a
        ret z
        ld  b,a
        cp  2fh                      ; is CAPS LOCK ?
        jr  nz,k_cl
        ld  (ix+_k_cnt),80h          ; yes - passivate repeator
        ld  a,(flag)
        xor 10h                      ; is _CAPS bit !!!!!!
        ld  (flag),a
        xor a
        ret
k_cl:   cp  2bh                      ; is ALT ?
        jr  nz,k_at
        ld  (ix+_k_cnt),80h          ; yes - passivate repeator
        jr  k_ok
k_at:   cp  7                        ; is SPACE
        jr  nz,k_ok
        bit _BREAK,(ix+_flag1)
        jr  nz,k_ok
        ld  a,(flag)
        or  3eh
        inc a
        jr  nz,k_ok
        ld  a,3
        rst 18h
        ld  hl,BIOS+3
        ld  (ENT_ADR),hl
        jp   ENTR2
k_ok:  ld   a,(tail)
       cp   maxqui
       ld  hl,(beep_t)
       jp   z,beep
       ld   hl,begqui
       call  add_hl_a
       inc  (ix+_tail)
       ld   (hl),b
       push hl
       ld hl,(beep_k)
       call beep
       pop  hl
; protection
				ret
       ld   a,(rtime)
       bit  4,(ix+_rtime+1)
       jr   z,knor
IF rom
       add  a,8
ELSE
       add  a,85h
ENDIF
knor:  sub  0e6h
       cp   7
       ret  c
       ld   a,r
       and  78h
       jr   nz,bad
       ld   hl,(time_c)
bad:   cp   10h
       ret  nc
       inc  (hl)
       ret

read_k::bit _flex_c,(ix+_flag)        ; read key for cp/m
        jr  z,read_w
        call stat_k
        jr  nz,rd_ki
        ld   a,1
        rst  18h
        push af
        call cur_ac
        pop  af
        rst  18h
        ei
        call read_w
        push af
        ld   a,1
        rst  18h
        push af
        call cur_pa
        pop  af
        rst  18h
        ei
        pop af
        ret

read_w:call stat_k
       or   a
       jr   z,read_w
rd_ki: call popkey
       call k_encode
       ret

popkey:ld   hl,begqui+1
       ld   de,begqui
       dec  (ix+_tail)
       ld   a,(de)
       ld   bc,maxqui-1
       ldir
       ret

stk_1: call popkey
stat_k::ld   a,(tail)
       or   a
       ret  z
       ld   a,(begqui)
       call k_encode
       or a
       jr z,stk_1
       ld   a,0ffh
       ret

read_knw:: ld a,(tail)           ; read key (no wait)
       or a                      ; out: key available: A-0
       ld a,1                    ;       C-char, H-scan, L-kb. type (0 for sinc)
       jr z,rknw                 ;       D-keyb flags (2 hi bit)
       call popkey               ;      no key available: A-1
       push af                   ;       D-keyb flags (2 hi bit)
       call k_encode
       ld  c,a
       pop hl
       xor a
rknw:  ld  l,0
       ld  d,(ix+_flag)
       ret

kb_typ::ld a,(tail)              ; read keyb type (L) & flags (D)
        or a                     ; & key avail. (A-0 av, A-1 no av.)
        ld a,1
        jr z,rknw
        xor a
        jr rknw

k_encode::
        ld e,a
        ld hl,kt_main
        call add_hl_a
        ld a,(hl)
        or a
        scf
        ret z
        cp ' '
        ret z
        cp 0dh
        jr nz,ken_2
        ld a,(flag)
        or 3eh
        inc a
        ld a,0dh
        ret nz
        ld a,0ah
        ret
ken_2:  ld d,0
        ex af,af'
        ld a,e
        bit _rus,(ix+_flag)
        jr z,is_nrext
        cp 3ah
        jr c,is_nrext
        sub 3ah
        ld hl,kt_rus
        call add_hl_a
        ld a,(hl)
        ex af,af'
        jr is_rext
is_nrext:cp 28h
        jr nc,is_ext
        dec a
        and 6
        cp 2
        jr nz,is_lit
        inc d
is_lit: inc d
is_ext: inc d
is_rext:ld a,(flag)
        and 0c0h
        rra
        rra
        rra
        rra
        add a,d
        ld hl,kt_jmp
        call add_hl_a
        ld a,(hl)
        call add_hl_a
        ex af,af'
        or a
        jp (hl)

DK      macro par
        irp mrk,<par>
         db  mrk-$
        endm
       endm

kt_jmp:  DK <<k_cret>,<k_eret>,<k_cret>,<k_ret>>
         DK <<k_lock>,<k_lock>,<k_syml>,<k_symn>>
         DK <<k_caps>,<k_?lit>,<k_caps>,<k_symn>>
         DK <<k_lock>,<k_lock>,<k_ctrl>,<k_lock>>

k_lock: xor a
        scf
k_ret:  ret
k_caps: xor 20h
k_cret: bit _caps,(ix+_flag)
        ret z
        xor 20h
        ret
k_ctrl: and 1fh
        ret
k_symn: sub 10h
	cp  '"'
	jr  z,ksn_1
	cp  ' '
	ret nz
	ld  a,'_'
	ret
ksn_1:  ld  a,'@'
        ret
k_?lit: sub '('
        cp 2
        jr nc,k_lock
        add a,a
        add a,'['
        ret
k_eret: or a
        ret p
        ld a,0eh
        bit _rus,(ix+_flag)
        ret nz
        inc a
        ret
k_syml: sub 'A'
        ld hl,kt_sym
        call add_hl_a
        ld a,(hl)
        or a
        ret nz
        scf
        ret

; tables
kt_main:db 0,'AQ10P',0DH,' '
        db 'ZSW29OL',0
        db 'XDE38IKM'
        db 'CFR47UJN'
        db 'VGT56YHB'
        db 18h,13h,5,80h,4,9,0,0,8,1bh
        db '*^/,-?.+(`=;):"_'
kt_rus: db 5bh,5fh,'=;',5dh,5eh,40h,5ch
kt_sym: db '~*?\',0,'{}^',0,'-+=.,;"',0,'<|>]/',0,'`[:'


