#include "allvars.ash"

;------------------------------
; externs from TEXTIO pakage
        extrn   RESET,_out_ch_,ADV_POS,GOTO_XY
        extrn   CURS_OO,CONV_COL,SET_CURS,CIO_MUX,CLW_WIND,ROL_WIND

UND_MUX:
IRG_FUN:  xor a
        ret

;--------------------------------------
; Window support procedures

; CONVERT WIN-RELATIVE TO ABS & CHECK
CHKCOR: LD   HL,(W_X1)
       ADD  HL,BC
       LD   B,H
       LD   C,L
_CHKCO: OR   A          ; ONLY CHECK
       EX   AF,AF'
       LD   A,(W_X1)
       CP   C
       JR   Z,_chs1
       JR   NC,_chx
_chs1: LD   A,(W_X2)
       CP   C
       JR   NC,chsh1
_chx:  LD   C,A
       EX   AF,AF'
       SCF
       EX   AF,AF'
chsh1: LD   A,(W_Y1)
       CP   B
       JR   Z,_chs2
       JR   NC,_chy
_chs2: LD   A,(W_Y2)
       CP   B
       JR   NC,chsh2
_chy:  LD   B,A
       SCF
       RET
chsh2: EX   AF,AF'
       RET

; SET CURSOR (W-RELATIVE & CHECK)
GOXY:  call chkcor
_GOXY: LD   (CUR_X),BC ;SET ABS & NO CHECK
       call GOTO_XY
       RET

; Cursor manipulation (on, off, invert)
CUR_IN::DEC  (IX+_C_CNT)
       RET  NZ
       LD   A,(C_MAX)
       LD   (C_CNT),A
       LD   A,(FLAG)
       XOR  2         ;C_STA bit
       LD   (FLAG),A
       EX   AF,AF'
       LD   A,(C_ACT)
       OR   A
       RET  NZ
       EX   AF,AF'
       RRA
       AND  1
       call CURS_OO
       RET

cur_ac1:ld  (IX+_C_ACT),1
CUR_AC::DEC  (IX+_C_ACT)
       JR   Z,ca_sh
       RET  P
       LD   (IX+_C_ACT),0
       RET
ca_sh: BIT  _C_STA,(IX+_FLAG)
       RET  Z			; Turn on cursor only if it mast be on screen
       LD   A,1			; just now (flag _c_status is on)
       call CURS_OO
       SET  _C_STA,(IX+_FLAG)
       RET

CUR_PA::LD   A,(C_ACT)
       INC  A
       LD   (C_ACT),A
       DEC  A
       RET  NZ
       BIT  _C_STA,(IX+_FLAG)
       RET  Z			; Turn off cursor only if it was on screen
       XOR  A			; just now (flag _c_status is on)
       call CURS_OO
       RES  _C_STA,(IX+_FLAG)
       RET

; ENCODING ROUTINE
encode:LD   B,A
       RLCA
       RLCA
       RLCA
       AND  7
       LD   HL,SG_ENC
       CALL ADD_HL_A
       LD   A,(HL)
       BIT  4,B
       JR   Z,esh
       RLCA
       RLCA
       RLCA
       RLCA
esh:   AND  0F0H
       XOR  B
       AND  0F0H
       XOR  B
       RET

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;     Protection
rom_chk::
       ld   bc,3fffh
       xor  a
       ld   h,a
       ld   l,a
rc_lp: add  a,(hl)
       adc  a,0
       inc  hl
       rrca
       xor  0b9h
       dec  bc
       ld   d,a
       ld   a,b
       or   c
       ld   a,d
       jr   nz,rc_lp
       dec  a
       ret  z
       ld   a,r
       ld   l,a
       ld   h,0dch                     ; is BDOS adress
       inc  (hl)
       and  7fh
       ret  nz
prot$::ld   hl,mes_rck
       xor  a
rc_plp:xor  (hl)
       inc  hl
       call nz,conout
       jr   nz,rc_plp
       ld   a,1
       rst  18h
rc_hlt:ld   hl,PAL_BUF
       ld   b,16
rc__1: inc  (hl)
       inc  hl
       djnz rc__1
       call SET_PAL
       ld   b,25
       ei
rc__2: halt
       djnz rc__2
       jr   rc_hlt
mes_rck:
       db   0Dh,16h,0Ah,58h,69h,43h,11h,13h,02h,08h,0Eh,01h,4Ah,0Eh
       db   69h,69h,48h,09h,0Dh,18h,11h,01h,4Ah,0Eh,70h,22h,17h,16h
       db   00h,53h,72h,17h,16h,16h,11h,74h,54h,1Bh,4Fh,43h,0Ch,01h
       db   1Ah,1Dh,07h,1Bh,10h,4Bh,00h,00h,2Eh
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

;--------------------------------
; roll window up
roll?: bit  _ROLL,(ix+_FLAG1)
       ret  nz
       xor  a
       jr   rol_1
;--------------------------------
; WROLL PROCEDURE. DIRECTION: 0-UP, 1-DOWN, 2-RIGHT, 3-LEFT
WROLL: pat  4
       ret  c
rol_1: ld   bc,(W_X1)
rol_2: ld   hl,(W_X2)
       sbc  hl,bc
       inc  h
       inc  l
       ex   de,hl
       jp   ROL_WIND

;-------------------------------
; INS/DEL CHAR PROCS
I_CH:  ld   d,2
       db   21h         ; ld hl,nn
D_CH:  ld   d,3
       call _prp_l
       jp   ROL_WIND

_prp_l:ld   a,(W_X2)
       sub  c
       ld   e,a
       inc  e
       ld   a,d
       ld   d,1
       ret

;--------------------------------
;CLEAR TO END OF SCREEN
CLREOL:
       call _prp_l
_clr:  ld   a,' '
       jp   CLW_WIND

; Init encoder
enc_init::
        ld  hl,enc_itab
        ld  de,SG_ENC
        ld  bc,12
        ldir
        ret
enc_itab:
        DB   01H,23H,45H,67H
        DB   01H,23H,0EFH,0CDH
        DB   01H,23H,45H,67H

;HOME CURSOR
PHOME: call rom_chk
HOME:  LD   BC,0
       JP   GOXY

;RESET WHOLE SCREEN
c_init_:                 ; console init (A-deep)
       call RESET

    ; set color '70'
       ld   de,'07'
       call set_color
    ; set encoder
       call enc_init
    ; turn on cursor
       ld   a,(C_ACT)
       or   a
       call nz,cur_ac1
    ; set LAT mode & CAPS
       res  _RUS,(ix+_flag)
       call RL_BRD
    ; reset all conio flag
       ld   (ix+_flag1),0

CLRALL:
       LD   (IX+_W_X1),0
       LD   (IX+_W_Y1),0
       LD   (IX+_W_X2),79
       LD   (IX+_W_Y2),24

CLRPG: CALL HOME
       ld   bc,(W_X1)

;CLEAR REST OF PAGE
CLR_EOP:
       CALL CLREOL
/*
       ld   hl,(RTIME)
#ifndef ATM
       ld   de,-0F4Bh
#else
       ld   de,-0EE8h
#endif
       add  hl,de
       ld   de,-5
       add  hl,de
       jr   nc,__1
       inc  (ix+_Hsign)
__1:
*/
       ld   b,(ix+_CUR_Y)
       inc  b
       ld   c,(ix+_W_X1)
       ld   hl,(W_X2)
       or   a
       sbc  hl,bc
       inc  h
       ret  z
       inc  l
       ex   de,hl
       jp   _clr

; OUT CHAR & ADVANCE POSITION
PUT_CH:
       CALL encode
_P_CHA:call _out_ch_
__pch: LD   A,(CUR_X)
       CP   (IX+_W_X2)
       JR   NC,n_pos
       INC  A
       LD   (CUR_X),A
       jp   ADV_POS
n_pos: LD   B,(IX+_CUR_Y)
       LD   C,(IX+_W_X1)
N_POS1:INC  B
       CALL _CHKCO
       PUSH BC
       CALL C,ROLL?
       POP  BC
_GOXY?:JP  _GOXY

;OUTPUT CHAR
OUT_CH:: CP  " "
       JP   NC,PUT_CH
       LD   BC,(CUR_X)
       patm1 <0DH,0AH,0EH,0FH,1BH,7,8,9>
       RET
       NOP
       JR   TAB_P
       JR   BS_P
       JR   BELL_P
       JR   ESC_P
       JR   DC1_P
       JR   DC3_P
       JR   N_POS1
CR_P:  LD   C,(IX+_W_X1)
       JR   _GOXY?

DC1_P: SET  _RUS,(IX+_FLAG)
       ld   a,1
       call KB_set_rus##
       LD   HL,ENC_SI
dcsh:  LD   DE,SG_ENC
       LD   BC,4
       LDIR
       JP   RL_BRD

DC3_P: RES  _RUS,(IX+_FLAG)
       xor  a
       call KB_set_rus
       LD   HL,ENC_SO
       JR   dcsh

ESC_P: LD   HL,ELET_P
set_sw:LD   (OUT_SW+1),HL
       RET

TAB_P: LD   A," "
       CALL _P_CHA
       LD   A,(CUR_X)
       AND  7
       JR   NZ,TAB_P
       RET

BS_P:  DEC  C
       CALL _CHKCO
       JR   NC,_GOXY?
       LD   C,(IX+_W_X2)
       DEC  B
       CALL _CHKCO
       JR   NC,_GOXY?
       LD   B,(IX+_W_Y2)
       JR   _GOXY?

BELL_P:LD   HL,(BEEP_D)
BEEP:: LD   A,(BORDER)
       LD   C,(IX+_FE_IMG)
       DI
bplp:  LD   B,H
       OUT  (C),A
       DJNZ $
       XOR  10H
       DEC  L
       JR   NZ,bplp
       EI
       RET

;ESC SEQUINCE CONTROL ROUTINE
ELET_P: SUB  "@"
       JR   NC,tst_l
RES_OU:LD   HL,OUT_CH
       ld   (ix+_c_stat),Cs_ersec
       JR   set_sw
tst_l: CP   NPAR_L
       JR   NC,RES_OU
       INC  A
       LD   (FUNC),A
       DEC  A
       LD   HL,NPAR_T
       CALL ADD_HL_A
       LD   A,(HL)
       OR   A
       JR   Z,do_pr
ACP_1: LD   HL,PAR1
       LD   (FCNT),A
       LD   (PAR_PT),HL
       LD   HL,ACC_PA
       JR   set_sw

ACC_PA: LD   HL,(PAR_PT)
       SUB  ' '
       JR   NC,AP_OK
       LD   (IX+_FUNC),0FFh
       ld   (ix+_c_stat),Cs_unprn
AP_OK: LD   (HL),A
       INC  HL
       LD   (PAR_PT),HL
       DEC  (IX+_FCNT)
       RET  NZ
do_pr:
       LD   HL,OUT_CH
       LD   (OUT_SW+1),HL
       LD   a,(FUNC)
       INC  a
       RET  Z
       DEC  a
       call IRG_FUN
       ld   bc,(CUR_X)
       ld   a,(par1)
       ex   af,af'
       LD   a,(FUNC)
       call _vjmp##
       db   NPAR_L+1
       dw   RES_OU
       DEFW SETP_AUX  ; SET PALLET EXECUTABLE PART
       DEFW PUT_CH, UP_P,   DN_P,   RT_P   ; '@ABC'
       DEFW LT_P,   CLRPG,  SET_CO, GRAPH  ; 'DEFG'
       DEFW PHOME,  RLF_P,  CLR_EOP,CLREOL ; 'HIJK'
       DEFW SET_CA, MODE,   PALLET, PLAY   ; 'LMNO'
       DEFW I_CH,   D_CH,   SETENC, I_LIN  ; 'PQRS'
       DEFW D_LIN,  BORD_P, GET_ALL ,WIND  ; 'TUVW'
       DEFW WROLL,  C_GOXY, S_CUR,  CUR_PAR; 'XYZ['
       DEFW KEY_PA, CUR_LN, SET_MOD,CLRALL ; '\]^_'
       DEFW SP_AUX, _CUR_PA,_KEY_PA,PRN_SC ; "'abcd"

NPAR_T:DEFB 1, 0, 0, 0  ; "@ABC"
       DEFB 0, 0, 2, 0  ; "DEFG"
       DEFB 0, 0, 0, 0  ; "HIJK"
       DEFB 16,1, 1, 1  ; "LMNO"
       DEFB 0, 0, 9, 0  ; "PQRS"
       DEFB 0, 2, 0, 4  ; "TUVW"
       DEFB 1, 2, 1, 1  ; "XYZ["
       DEFB 2, 2, 2, 0  ; "\]^_"
       DEFB 16,1, 2, 16 ; "'ab "
NPAR_L EQU  $-NPAR_T

GET_ALL:
GRAPH:
PLAY:  ld   a,-1
       ret

UP_P:  DEC  B
       CALL _CHKCO
       JR   NC,GO
       LD   B,(IX+_W_Y2)
GO:    JP   _GOXY

DN_P:  INC  B
       CALL _CHKCO
       JR   NC,GO
       LD   B,(IX+_W_Y1)
       JR   GO

RT_P:  INC  C
       CALL _CHKCO
       JR   NC,GO
       LD   C,(IX+_W_X1)
       JR   GO

LT_P:  DEC  C
       CALL _CHKCO
       JR   NC,GO
       LD   C,(IX+_W_X2)
       JR   GO

RLF_P: INC  B
       DEC  B
       SCF
       JR   Z,RLF_SK
       DEC  B
       CALL _CHKCO
RLF_SK:PUSH BC
       ld   a,1
       CALL C,rol_1
       POP  BC
       JP   _GOXY

SET_CA:
SET_CO:ld    de,(par1)
set_color:
       ld    a,e
       ld    bc,(color_p)
       patm 'NI' uc hex
       ret   c          ; num or err
       nop
       ld    b,a        ; invert or num
       nop
       ld    a,d        ; ignore
       patm 'NI' uc hex
       ret   c          ; num or err
       nop
       ld    c,a        ; invert or num
       nop
       ld    (color_p),bc
       BIT  7,B                 ; Not change
       JR   Z,schs1
       LD   A,C
       CALL INVERT
       LD   B,A
schs1: BIT  7,C
       JR   Z,schs2
       LD   A,B
       CALL INVERT
       LD   C,A
schs2: CALL PCK
       jp   CONV_COL

;PACK ATTRIBUTE BYTE
PCK:   LD   A,B       ;in B-INK, C-PAPER
       XOR  C         ;out A-COLOR
       AND  0F8H
       XOR  C
       RL   C
       XOR  C
       AND  0EFH
       XOR  C
       RLA
       RLA
       RLA
       XOR  B
       AND  0F8H
       XOR  B
       RET

SET_MOD:patm 'IRBFTO' uc
       NOP
       RET  C
       AND  7FH
       LD   B,A
       INC  B
       XOR  A
       SCF
SM_L:  RLA
       DJNZ SM_L
       LD   C,A
       LD   A,(PAR2)
       pat  2
       RET  C
       RRA
       SBC  A,A
       LD   B,(IX+_FLAG1)
       XOR  B
       AND  C
       XOR  B
       LD   (FLAG1),A
loc_ret:RET

;MODE PROCEDURE
MODE:: ld   a,(par1)
       sub  '0'-' '
       ld   b,a
       call set_mode
       ld   (sys_p),a
       call set_sys##

       ld   (ix+_C_ACT),1 ; flag 'cursor off'
       ld   h,40h      ; clear physical screen
       call _md1
       ld   h,60h
       call _md1
       ld   h,0c0h
       call _md1
       ld   h,0e0h
       call _md1
       ;call tst_rt##
       ld   a,2
       jp   c_init_
_md1:  ld   l,0
       ld   d,h
       ld   e,1
       ld   bc,8000-1
       ld   (hl),l
       ldir
       ret

set_mode:
       ld   a,(sys_p)
       and  not 7
       dec  b
       jr   z,mod_txt
       dec  b
       ret  nz
       or   2
       ret
mod_txt:
       or   6
       ret

;BORDER & BORD COLOR MANIP ROUTINES
BORD_P:pat  uc hex
       RET  C
       LD   C,A
       LD   A,(PAR2)
       pat  uc hex
       RET  C
       RRCA
       RRCA
       RRCA
       RRCA
       XOR  C
       AND  0F0H
       XOR  C
       LD   (BCOL),A

RL_BRD: LD   A,(BCOL)
       BIT  _RUS,(IX+_FLAG)
       JR   NZ,SET_BR
       RRA
       RRA
       RRA
       RRA

SET_BR:LD   C,A
       XOR  (IX+_BORDER)
       AND  7
       XOR  (IX+_BORDER)
       LD   (BORDER),A
       LD   A,(FE_IMG)
       XOR  C
       AND  0F7H
       XOR  C
       XOR  8
       LD   (FE_IMG),A

OUT_FE:LD   C,(IX+_FE_IMG)		; 19
       LD   A,(BORDER)			; 13
       OUT  (C),A			; 12
       RET				; 10  / 54 (+17 = 71)

;GOTOXY PROC
C_GOXY: LD  C,(IX+_PAR2)
       LD   B,A
       JP   GOXY

;WINDOW PROC
WIND:  LD   A,(PAR3)
       CP   (IX+_PAR1)
       RET  C
       LD   L,A
       CP   80
       RET  NC
       LD   A,(PAR4)
       CP   (IX+_PAR2)
       RET  C
       CP   25
       RET  NC
       LD   H,A
       LD   (W_X2),HL
       LD   HL,(PAR1)
       LD   (W_X1),HL
       JP   HOME

I_LIN: ld   a,1
       db   0eh         ; ld c,n
D_LIN: xor  a
       ld   c,(ix+_W_X1)
       jp   rol_2

S_CUR: pat  3
       RET  C
       RES  _FLEX_C,(IX+_FLAG)
       DEC  A
       JP   Z,CUR_AC
       INC  A
       EX   AF,AF'
       CALL CUR_PA
       EX   AF,AF'
       RET  Z
       SET  _FLEX_C,(IX+_FLAG)
       RET

CUR_PAR:pat uc 32
       RET  C
       CALL LOG
_CUR_PA:LD  (C_MAX),A
       RET

_KEY_PA:LD  (KEY_REP),A
       LD   A,(PAR2)
       JR   _KP_1
KEY_PA:pat uc 32
       RET  C
       CALL LOG
       LD   (KEY_REP),A
       LD   A,(PAR2)
       pat uc 32
       RET  C
       CALL LOG
_KP_1: ADD  A,A
       DEC  A
       LD   (KEY_DEL),A
       RET

LOG:   INC  A
       CP   16
       RET  C
       SUB  8
       CP   16
       JR   C,LOG1
       SUB  8
       ADD  A,A
LOG1:  ADD  A,A
       RET

CUR_LN:pat  8
       RET  C
       LD   B,A
       LD   A,(PAR2)
       pat  8
       RET  C
       CP   B
       RET  C
       LD   C,A
       jp   SET_CURS

SETENC:pat  3
       RET  C
       ADD  A,A
       LD   HL,SG_ENC
       CALL ADD2_HL_A
       LD   DE,PAR2
       LD   B,8
SEC_LP:LD   A,(DE)
       INC  DE
       pat  uc hex
       RET  C
       RLD
       BIT  0,B
       JR   Z,SEC_1
       INC  HL
SEC_1: DJNZ SEC_LP
MY_RET::RET

PRN_SC:ld   c,0
       jp   UND_MUX

PALLET:patm 'RT' uc hex
       RET  C
       NOP
       jr   plt_1
       JR   SP_DEF
plt_1: LD   (PAR4),A
       XOR  A
       LD   (FUNC),A
SPA_s: LD   A,3
       JP   ACP_1

SP_DEF::LD   HL,PALN##
       JR   SP_AUX1


SP_AUX::LD   HL,PAR1
SP_AUX1:
SP_DIR::
       LD   DE,PAL_BUF
       LD   BC,16
       LDIR
       JR   SET_PAL

SETP_AUX:
       LD   B,3
       LD   D,0
       LD   HL,PAR1
PACC_: LD   A,(HL)
       pat  4
       RET  C
       CPL
       RRA
       RRA
       RL   D
       RLA
       SBC  A,A
       AND  8
       OR   D
       LD   D,A
       INC  HL
       DJNZ PACC_
       add  a,a
       add  a,a
       xor  d
       and  0FCh
       xor  d
       or   0ch
       ld   d,a
       LD   HL,PAL_BUF
       LD   A,(PAR4)
       AND  7FH
       CALL ADD_HL_A
       LD   (HL),D                      ; page 1 sets on entry to conout
       INC  (IX+_PAR4)
       JP   P,SET_PAL
       BIT  4,(IX+_PAR4)
       JR   Z,SPA_s
;----------------------
; SET PALLET FROM PAL_BUF
SET_PAL: DI
       LD   A,I
       PUSH AF
       LD   A,HIGH(MY_R_ADR##)           ; 3dh
       LD   I,A
       IM   2

       ld      a,(sys_p)
       ld      bc,0BD77h
       out     (c),a

       LD   A,(BORDER)
       AND  0F8H
       LD   HL,PAL_BUF
       LD   C,0FFH
       LD   D,8
       EXX
       LD   C,(IX+_FE_IMG)
       SET  3,C
       EXX
       EI
       HALT
       DI
SPL:   EXX                  ;  4          x 8
       OUT  (C),A           ;  12
       EXX                  ;  4
       OUTI                 ;  16
       INC  A               ;  4
       DEC  D               ;  4
       JR   NZ,SPL          ;  12  /7           => 443
       EXX                  ; 4
       RES  3,C             ; 8
       EXX                  ; 4
       SUB  8               ; 7
       LD   D,8             ; 7                 => 30
SPL1:  EXX                  ;  4          x 8
       OUT  (C),A           ;  12
       EXX                  ;  4
       OUTI                 ;  16
       INC  A               ;  4
       DEC  D               ;  4
       JR   NZ,SPL1         ;  12  /7           => 443
       add  a,0			; +7
       call out_fe		; +71 / +78 = 13*6
       POP  AF              ; 10
       LD   I,A             ; 9
       IM   1               ; 8

/*
       ld   a,(sys_p)       ; 13
       and  076h            ; 7
       or   41H             ; 7                 => 54    => 977  (+55 djnz)

       ld   b,S1_DELAY      ; 7

       djnz $

       ld   bc,0FD77h       ; 10
       out  (c),a           ;   (1688 -711)
       and  not 1
       out  (c),a
*/
       call set_sys
/*
#ifdef NOPROT
       ld   de,0
#else
       ld   de,(0)
#endif
       ld   de,S1_CONST

       call sign1##
       ld   a,h
       xor  l
       ld   (Hsign),a
;       in   a,(0FEh)
*/
       EI
       LD   BC,1000H                   ; FIND MIN&MAX COLORS
       LD   DE,0FFH                    ; D - max, E - min
       LD   HL,PAL_BUF
FIV_LP:CALL CLT
       CP   D
       JR   C,FIV_NU
       LD   D,A
       LD   (IX+_I_MAX),C
FIV_NU:CP   E
       JR   NC,FIV_ND
       LD   E,A
       LD   (IX+_I_MIN),C
FIV_ND:INC  C
       INC  HL
       DJNZ FIV_LP
       LD   A,D
       ADD  A,E
       LD   (I_AVR),A
       JP   RL_BRD

INVERT:PUSH HL
       LD   HL,PAL_BUF
       CALL ADD_HL_A
       CALL CLT
       ADD  A,A
       LD   HL,I_AVR
       CP   (HL)
       POP  HL
       LD   A,(I_MIN)
       RET  NC
       LD   A,(I_MAX)
       RET

CLT:   PUSH HL
       PUSH BC
       LD   C,(HL)
       LD   HL,CLT_TB
       LD   B,6
       XOR  A
CLT_LP:RR   C
       JR   C,CLT_1
       ADD  A,(HL)
CLT_1: INC  HL
       DJNZ CLT_LP
       POP  BC
       POP  HL
       RET

CLT_TB:DB   2,6,0CH,1,3,6

;------------------------------------------------
CONOUT::PUSH BC       ;PRINT CHAR FROM A
       PUSH DE       ;DESTROY ALL ALT REGS
       PUSH HL       ;IX MAST POINT TO IX_BASE
       PUSH IY
       PUSH AF
       EX   AF,AF'
       LD   A,1
       RST  18H
       PUSH AF
       CALL CUR_PA
       EI
       EX   AF,AF'
       CALL OUT_SW
       CALL CUR_AC
       POP  AF
       RST  18H
       EI
       POP  AF
       POP  IY
       POP  HL
       POP  DE
       POP  BC
       RET
end
