#ifndef __MISK__
#define __MISK__

debug   equ     0
CPT_points equ  0

.xlist
.z80
;--- aux macro
..am    macro   p
ifb <p>
..amv   defl    0ffh
        exitm
endif
ifidn <p>,<usr?>
..amv   defl    0feh
        exitm
endif
ifidn <p>,<usr>
..amv   defl    0fdh
        exitm
endif
ifidn <p>,<def>
..amv   defl    0ffh
        exitm
endif
ifidn <p>,<sys>
..amv   defl    3
        exitm
endif
..amv   defl    p
        endm

;--------------------------------
; inter page move macro
; usage: p_ldir [<dest page>] [<src page>]
;   <page> is <num> or 'sys' or 'usr?' or 'usr' or 'def'
;
p_ldir  macro   dest,src
        rst     8
        ..am    dest
        db      ..amv
        ..am    src
        db      ..amv
        endm

;--------------------------------
; load/store macro
; usage: lda [<src page>] ['pp'] (is increment flag)
;   <page> is <num> or 'sys' or 'usr?' or 'usr' or 'def'
lda     macro   src,flag
        rst     10h
ifidn <src>,<pp>
        db      0ffh
        exitm
endif
        ..am    src
ifnb <flag>
        db      (..amv and 3fh) or 0c0h
else
        db      (..amv and 3fh) or 080h
endif
        endm

; usage: sta [<dest page>] ['pp'] (is increment flag)
;   <page> is <num> or 'sys' or 'usr?' or 'usr' or 'def'
sta     macro   src,flag
        rst     10h
ifidn <src>,<pp>
        db      3fh
        exitm
endif
        ..am    src
ifnb <flag>
        db      (..amv and 3fh) or 40h
else
        db      ..amv and 3fh
endif
        endm

;--------------------------------
; patten match macro
..am3   macro   p, gmac, len
        local   pc
ifidn <p>,<dec>
        db      (..amv or 2) + len*8
ifnb <gmac>
pc:     gmac
else
pc:
endif
len     equ     $-pc
        exitm
endif
ifidn <p>,<hex>
        db      (..amv or 4) + len*8
ifnb <gmac>
pc:     gmac
else
pc:
endif
len     equ     $-pc
        exitm
endif
        db      (..amv or 6) + len*8
ifnb <gmac>
pc:     gmac
else
pc:
endif
len     equ     $-pc
        db      p
        endm

..pat   macro   gmac, ucflag, limf
        local   len, pc
ifb <ucflag>
        db      0 + len*8
ifnb <gmac>
pc:     gmac
else
pc:
endif
len     equ     $-pc
        exitm
endif
ifidn <ucflag>,<uc>
 ifb <limf>
        db      1 + len*8
ifnb <gmac>
pc:     gmac
else
pc:
endif
len     equ     $-pc
        exitm
 endif
..amv   defl    1
        ..am3   limf <gmac> len
else
..amv   defl    0
        ..am3   ucflag <gmac> len
endif
        endm

; usage: pat[1] ['uc'] ['dec' or 'hex' or <number>] ('uc' is upper case flag)
;
pat     macro   ucflag, limf
        call    hex_cvt##        ;; add ' ' to A
        ..pat   <>, ucflag, limf
        endm

pat1    macro   ucflag, limf
        call    hex1_cvt##
        ..pat   <>, ucflag, limf
        endm

; usage: patm[1] ('pat str' or '<'<pat num's>'>') ['uc']
;                ['dec' or 'hex' or <number>]
patm    macro   str, ucflag, limf
        call    hex_cvt##        ;; add ' ' to A
        ..pat   <db str>, ucflag, limf
        endm

patm1   macro   str, ucflag, limf
        call    hex1_cvt##
        ..pat   <db str>, ucflag, limf
        endm

;--------------------------------
; Vectorize jump & call macro
; usage: vjmp  <adr1,adr2,...>
vjmp    macro   par
        local   sz,m
        call    _vjmp##
        db      sz/2
m:      irp     p,<par>
        dw      p
        endm
sz      equ     $-m
        endm

; usage: vcall <adr1,adr2,...>
vcall   macro   par
        local   m1,m2
        call    m1
        jr      m2
m1:     vjmp    <par>
m2:
	endm

.list
;--------------------------------
; inter page move macro
; usage: p_ldir [<dest page>] [<src page>]
;   <page> is <num> or 'sys' or 'usr?' or 'usr' or 'def'

;--------------------------------
; load/store macro
; usage: lda [<src page>] ['pp'] (is increment flag)
;   <page> is <num> or 'sys' or 'usr?' or 'usr' or 'def'
; usage: sta [<dest page>] ['pp'] (is increment flag)
;   <page> is <num> or 'sys' or 'usr?' or 'usr' or 'def'

;--------------------------------
; patten match macro
; usage: pat[1] ['uc'] ['dec' or 'hex' or <number>] ('uc' is upper case flag)
; usage: patm[1] ('pat str' or '<'<pat num's>'>') ['uc']
;                ['dec' or 'hex' or <number>]

;--------------------------------
; Vectorize jump & call macro
;  num into A. value of A into A'
; usage: vjmp  <adr_ovr,adr1,adr2,...>
; usage: vcall <adr_ovr,adr1,adr2,...>

;---------------------------------
; Externals:
        extrn  add_hl_a
        extrn  add2_hl_a
        extrn  ed_set      ; set page for lda/sta

T       macro   p
if debug
        p
endif
        endm

if CPT_points
?cptm_  macro v
	LD A,v+0
	endm

??cpt?? defl 0
CPT     macro   v
        push    af
ifb <v>
        ?cptm_ %??cpt??
??cpt?? defl ??cpt?? + 1
else
        ?cptm_ v
endif
        out     (0fbh),a
        pop     af
        endm
else
CPT	macro v
	endm
endif

DG      macro   par
        call    prn##
        db      par,0dh,0ah,0
        endm


#endif

