.z80
#include "allvars.ash"

#pragma local

;   conio
        cseg
	ORG    0
        DI
        JP     h_init##
pm_run_4000:
        out     (c),e
        nop

	ORG	8H
        JP      RST8##

;        ORG     10H
;        JP      RST10##

	ORG	18H
	JP	SET_PG

        ORG     20H
        JP      conout##

;	ORG	28H
;	JP	RST28

;	ORG	30H
;	JP	RST30

	ORG    38H
	JP     DO_INT

PAL_MN:

#include "pallet.inc"


; CONVERT PAGE NUMBER
ED_PG:: ADD     A,6
        RET

; SET PAGE NUMBER
SET_PG::DI
        push    bc
        LD      B,(IX+_MEMDSP)
        LD      (MEMDSP),A
        and     3fh
        call    s_pg1
        pop     bc
        ret

S_PG1:  di
        or      080h
        PUSH    BC
        cpl
        ld      bc,0fc77h
        push    de
        ld      e,(ix+_sys_p)
        out     (c),e
        ld      bc,0fff7h
        out     (c),a
        ld      bc,0fd77h
        out     (c),e
        pop     de
        POP     AF
        RET


ENTRY:: LD      SP,SYS_SP       ; MUST BE CPSYS
        IM      1

        ld      hl,(TST_1run)
        ld      de,55AAh
        xor     a
        sbc     hl,de
        ld      (TST_1run),de
        jr      z,all_init
        ld      (ix+_TST_is1),-1

ALL_INIT:
        LD      A,'1'-' '
        CALL    C_INIT##
        CALL    M_INIT##
#ifndef VE31
        call    CI_init##
#endif

CPM_RINI:
        LD      A,'1'-' '
        CALL    C_INIT
        CALL    M_INIT
#ifndef VE31
        call    CI_init##
#else
	ld	a,55h
	in	a,(0FEh)
	ld	a,1
	in	a,(0FEh)
        ld      a,55h
        in      a,(0FEh)
        ld      a,8
        in      a,(0FEh)
	xor	a
	in	a,(0FEh)
#endif
        ei

#ifndef TEST

        LD   HL,PAL_MN
        CALL SP_DIR##

        LD    SP,0B000H
        ld      a,65h          ; TR-DOS page(65) (!!! 64h for emulator !!!)
        call    s_pg1
        LD      DE,8000H
        LD      HL,0C805H
        LD      BC,2043
        LDIR
        LD      HL,0F1FDH
        LD      BC,2564
        LDIR

        call    chk_sum
        ld      a,3
        rst     18h


;---------------------------------
; Main menu manager.
;
; In:  A - 1 for RU7, 0 for RU5
;      E - IBMpc keyboard locks status
; Out: A - selection (0-cp/m,1-tr-dos,2-s128,3-s48)
;      D - 1 for 'turbo' mode, 0 in other case
;      E - IBMpc keyboard locks status
;      L - 1 for IMBpc keyboard, 0 for Spectrum keyboard
        ld      e,(ix+_ks_shifts)
        ld      a,1
        di
        call    8003h
        push    af

        ld      ix,IX_BASE
        ld      (ix+_ks_shifts),e
        dec     d
        jr      nz,_no_tur
        set     3,(ix+_sys_p)
_no_tur:
#ifndef VE31
        dec     l
        ld      hl,IBMkeyb_t##
        jr      z,_2_
#else
        ld      a,55h
        in      a,(0FEh)
        ld      a,8
        in      a,(0FEh)
	ld	a,8Ah
	in	a,(0FEh)
        ld      a,55h
        in      a,(0FEh)
        ld      a,1
        in      a,(0FEh)

	ex	af,af'
        ld      a,55h
        in      a,(0FEh)
        ld      a,8
        in      a,(0FEh)
	xor	a
	in	a,(0FEh)
	ex	af,af'

        cp      10
        jr      nc,@@1
        ld      a,55h
        in      a,(0FEh)
        ld      a,7
        in      a,(0FEh)
        ld      hl,IBMkeyb_t##
	jr	_2_
@@1:
#endif
        ld      hl,SPkeyb_t##
_2_:    ld      de,keyboard
        ld      bc,6*3
        di
        ldir
        ei

        ld      a,3
        rst     18h

        CALL SP_DEF##
        pop     af
        OR      A
        JP      NZ,8000h
#endif

#ifdef VE31
        call    CI_init##
#endif

GOCPM:  LD      SP,SYS_SP
        call    prn##
        db      1bh,'_',0

        call    mem_size##

#ifndef TEST
        CALL    CPM_LOAD##

        call    cfg_load##
        jp      entr1
#else
        jp      tst_loop##
#endif


DO_INT:
        PUSH AF
       PUSH BC
       PUSH DE
       PUSH HL
       EX   AF,AF'
       EXX
       PUSH AF
       PUSH BC
       PUSH DE
       PUSH HL
       PUSH IX
       LD   IX,IX_BASE
       LD   A,1
       RST  18H
       PUSH AF
       LD   HL,TIME_C
       LD   B,4
TM_L:  INC  (HL)
       INC  HL
       JR   NZ,TM_DN
       DJNZ TM_L
TM_DN: CALL CUR_IN##
       CALL keyboard
       POP  AF
       RST  18H
       POP  IX
       POP  HL
       POP  DE
       POP  BC
       POP  AF
       EXX
       EX   AF,AF'
       POP  HL
       POP  DE
       POP  BC
       POP  AF
       EI
       RET

;---------------------------
; MULTYPLEXOR CALL
;
DO_MUX: EI
	PUSH HL
        PUSH DE
	PUSH AF
	LD   A,MUX_LNG-1
	CP   C
	JR   NC,MUX_OK
	POP  AF
	LD   A,0FFH
        POP  DE
	POP  HL
	RET
MUX_OK: LD   A,C
	LD   HL,MUX_TBL
        CALL _IND##
	POP  AF
        POP  DE
	EX   (SP),HL
	RET

MUX_TBL: DW R_VER, CPM_L, SET_RST ; func 0,1,2
         DW reada_knw          ; (3) read key (no wait) (see scankey)
         DW kb_typ             ; (4) read keyb type (L) & flags (D)
         DW g_time             ; (5) get current time
         DW wr_fe              ; (6) write to 'FE' port
         DW adr_fe             ; (7) get address & default of 'FE' port
         DW wr_sys             ; (8) write to SYS port ('ton' & 'tnab' bits)
         DW adr_sys            ; (9) get address & default of SYS port
         DW page_man	       ; (10)
                     ; debug
/*
#ifdef NOPROT
         DW phex##             ; (11) print 1 hex (from A)
         DW phexw              ; (12) print HL
         DW pdump##            ; (13)
#endif
*/
MUX_LNG  EQU ($-MUX_TBL)/2
/*
#ifdef NOPROT
sig1:   ld      S1_CONST,hl
	ld      hl,(Hsign)
	ld	h,0
        xor     a
        ret

phexw:: push    af
        ld      a,h
        call    phex1##
        ld      a,l
        call    phex
        pop     af
        ret
#endif
*/
R_VER:  LD      HL,107h ; MUX FUNC 0 - GET VERSION (HL-VERSION)
        LD      DE,-1
	XOR	A
	RET

CPM_L:  LD	BC,1600H; MUX FUNC 1 - LOAD CPM IMAGE
        CALL    CPM_L1##
	XOR	A
	RET

SET_RST:LD      DE,(ENT_ADR)    ; MUX FUNC 2 - SET RESTART ADRESS
        LD      (ENT_ADR),HL    ; HL - ADRESS FOR RESTART (RET in HL old)
        EX      DE,HL
	XOR	A
	RET

g_time: ld      de,(TIME_C)     ; MUX FUNC 5 - get time into hl:de
        ld      hl,(TIME_C+2)
        xor     a
        ret

adr_sys:
wr_sys:
adr_fe:
wr_fe:
err_ff: ld      a,0ffh
        ret

chk_sum:ld      hl,0C000h
        xor     a
cs_lp:  add     a,(hl)
        adc     a,0
        inc     hl
        bit     7,h
        jr      nz,cs_lp
        dec     a
        ret     z
        jp      prot$##

;---------------------------------------
; Page manipulation
page_man:
        ld      a,e
        cp      7
        jr      z,pm_tst_ru5
        jr      nc,pm_err_1
pm_2:   ld      (tmp_w),hl
        ld      hl,pm_rom_tab
        cp      4
        jr      nc,pm_1
        ld      hl,pm_ram_ru5
        bit     _ru5,(ix+_flag)
        jr      nz,pm_1
        ld      hl,pm_ram_ru7
pm_1:   bit     0,a
        jr      z,pm_3
        ld      a,6
        call    add_hl_a
pm_3:   ld      a,b
        vjmp    <err_ff,pm_get_inf,pm_set_pg,pm_go>
pm_tst_ru5:
        bit     _ru5,(ix+_flag)
        jr      z,pm_2

pm_err_1:
        ld      a,1
        ret
pm_err_2:
        ld      a,2
        ret
pm_err_3:
        ld      a,3
        ret

pm_get_inf:
        ld      a,d
        cp      6
        jr      nc,pm_err_2
        call    add_hl_a
        ld      d,(hl)
        xor     a
        ret

rcall   macro   addr
        local   raddr
        ld      sp,raddr
        jp      addr
raddr:  dw      $+2
        endm

pm_go:  ld      a,d
        push    hl
        pop     iy
        inc     hl
        exx
        ld      hl,pm_go_tab
        cp      3
        jr      nc,pm_err_3
        call    _ind
        ld      de,4004h
        ld      bc,32-4
        ldir
        ld      e,(ix+_sys_p)
        di
        im      0
        ld      bc,0C077h
	xor	a
        out     (c),a           ; Page Manager off
        ld      bc,7ffdh
        out     (c),a
        ld      a,(iy+4)
        rcall   pm_set          ; rg0-0, rom2-0
        ld      a,10h
        ld      bc,7ffdh
        out     (c),a
        ld      a,(iy)
        rcall   pm_set          ; rg0-0, rom2-1
        ld      bc,0C077h
        ld      a,6
        out     (c),a
        ld      a,(iy+5)
        rcall   pm_set          ; rg0-1, rom2-1
        xor     a
        ld      bc,7ffdh
        out     (c),a
        ld      a,(iy+5)
        rcall   pm_set          ; rg0-1, rom2-0
        ld      bc,0ff77h
        ld      a,e
        and     not 7
        or      3
        ld      e,a
        jp      pm_run_4000

pm_set:   exx
          ld e,l
          ld d,h
          ld bc,0f7h
          jr pm_s_1
page_l1:  ld a,(de)
          inc de
pm_s_1:   xor 80h
          cpl
          out (c),a
          ld a,b
          add a,40h
          ld b,a
          jr nc,page_l1
          exx
          ret


;------------------------------------------
;   dmon
#include "DDEF.asm"

        cseg


SYS_SP EQU  8000H
        global  sys_sp

; Interface to rom bios

MON_IMG::

.PHASE 0F800H
@RUN:   JP  RUN              ; Main menu of loader
@CI:    JP  CI               ; Consol in
@RI:    JP  RI               ; Reader in
@CO:    JP  CO               ; Consol out
@PO:    JP  POUT             ; Punch out
@LO:    JP  LOUT             ; List out
@CSTS:  JP  CSTS             ; Consol status
@IOCHK: JP  IOCHK            ; Get IO state
@IOSET: JP  IOSET            ; Set IO state
@MEMCK: JP  MEMCK            ; Get top of ram
@IODEF: JP  RET_RAM          ; Set user IO
@REST:  JP  IRUN             ; Interrupt entry
@RQDIO: JP  RQDIO            ; Call to disk monitor
@RQRES: JP  RQRES            ; Buffer reset
@RQSET: JP  RQSET            ; Chanall assign
@RQCHK: JP  RQCHK            ; Get chanall description block
@MUX:   JP  MUX

; temporary
RI:
POUT:

RET_RAM: NOP
         RET

RUN:    CALL S_ON
	JP   ALL_INIT
IRUN:	CALL S_ON
	RST  0

MUX:    CALL    SYS_ON
	CALL	DO_MUX
	CALL	SYS_OFF
	EI
	RET

lport   equ     0fbh

LOUT:   IN A,(lport)
	RLCA
	JR C,LOUT
	LD A,C
	OUT (0FBH),A
	OUT (07BH),A
	OUT (0FBH),A
	RET

MEMCK:  LD      B,0F8H
        LD      A,0
        RET

ENTR1:
        CALL    S_OFF
        IM      2
        JP      BIOS

ENTR2:: CALL    S_OFF
        IM      2
	call    BIOS+3
ENT_ADR EQU 	$-2
        global  ENT_ADR
        CALL    S_ON
        IM      1
        RET

;----------------------
RQRES:  CALL    SYS_ON
        LD      (IX+_BUFT),0FFH
        CALL    SYS_OFF
        EI
        RET
;-----------------------
RQSET:  LD      A,_SETCH
        JR      SETCHK
;-----------------------
RQCHK:  LD      A,_GETCH
SETCHK: CALL    SYS_ON
        CALL    PSCHK##
        CALL    SYS_OFF
        EI
        RET

;----------------------
RQDIO:  CALL    SYS_ON
        CALL    PDISK##
        CALL    SYS_OFF
        EI
        RET

;----------------------
CO:     CALL    SYS_ON
        EI
        PUSH    AF
        LD      A,C
        CALL    CONOUT
        POP     AF
        CALL    SYS_OFF
        EI
        RET

;----------------------
CI:     CALL    SYS_ON
        EI
        CALL    READ_K
        CALL    SYS_OFF
        EI
        RET

;----------------------
CSTS:   CALL    SYS_ON
        CALL    STAT_K
        CALL    SYS_OFF
        EI
        RET

;----------------------
;  /
IOSET:  LD      A,C
        LD      (IOBYTE),A
        RET
;----------------------
;  /
IOCHK:  LD      A,(IOBYTE)
        RET

;----------------------
;System on/off proc's
S_ON:   DI
        LD      (RA_I),A
        LD      A,52h
sys_sw: EX      (SP),HL
        LD      (R_ADR),HL
        POP     HL
        out     (0fdh),a
        LD      A,0
RA_I    EQU     $-1
        JP      0
R_ADR   EQU     $-2

SYS_ON:: DI
        EX      (SP),HL
        LD      (R_1),HL
        POP     HL
        CALL    S_ON
        LD      (OLD_SP),SP
        LD      SP,SYS_SP
        IM      1
        PUSH    IX
        LD      IX,IX_BASE
        JP      0
R_1     EQU     $-2

S_OFF:  DI
        LD      (RA_I),A
        LD      A,42h
        JR      sys_sw

SYS_OFF:: DI
        EX      (SP),HL
        LD      (R_2),HL
        POP     HL
        POP     IX
        CALL    S_OFF
        LD      SP,(OLD_SP)
        IM      2
        JP      0
R_2     EQU     $-2

INT_R:  di
        LD      (OLD_SP),SP
        LD      SP,SYS_SP
        IM      1
        LD      (I_A_I),A
        LD      A,52h
        OUT     (0fdh),A
        CALL    DO_INT
        LD      A,42h
        OUT     (0fdh),A
        LD      A,0
I_A_I   EQU     $-1
        DI
        LD      SP,(OLD_SP)
        IM      2
        EI
        RET

;------------------------
pm_set_pg:
        ld      a,(tmp_w)
        cp      3
        jp      nc,pm_err_3
        pop     bc
        call    sys_off
        rrca
        rrca
        and     0C0h
        ld      b,a
        ld      a,d
        xor     80h
        cpl
        ld      c,0f7h
        out     (c),a
        xor     a
        ei
        ret

CHTBL:: DW      CH0          ; Chanall descriptions
        DW      CHed
        DW      CH2
        DW      CH3
        DW      CH4
        DW      CH5
        DW      CH6
        DW      CH7
        DW      CH8
        DW      CH9

;-----------------------
; 
DCTBL:: DW      0       ;
        DW      0       ;PD1207
        DW      ED_DRV##
        DW      FDC_DRV##
        DW      HD_DRV##;WD1207
        DW      0       ;
        DW      0       ;
        DW      0       ;
;-----------------------

OLD_SP: DS      2

QQ      EQU     $

        DEFS    (256*HIGH($+255))-$-1

PRINT <Idle space > %($-QQ)

INTRADR::DW     INT_R

;-----------------------
;   80X2
CH0:    DB      0FFH    ; 
        DB      3       ; 
        DB      0       ; 
        DB      0       ;    
        DB      0       ;  
        DB      2       ;  
        DW      80      ;   
        DB      16      ;   
        DW      256     ;   
        DB      2       ;  
        DW      0       ;  
        DW      5120    ;   
        DW      32      ;   
        DW      160     ;   
        DB      8       ;    
        DW      128     ;   
        DB      2       ;  
        DB      2       ;  
        DB      2       ;   
        DB      0       ;  
        DB      0       ; 8- 
        DB      0FFh    ; 
        DB      1       ; 
        DB      80      ;GAP3  /
        DB      80      ;GAP3  
        DB      0    ; 
        DB      0       ;  
        DB      0       ;  

;-----------------------
;HDD 80X2
CH2:    DB      0FFH    ; 
        DB      4       ; 
        DB      0       ; 
        DB      0       ;    
        DB      5       ;  
        DB      0       ;  
        DW      150     ;   
        DB      17      ;   
        DW      512     ;   
        DB      1       ;  
        DW      0       ;  
        DW      50660   ;   
        DW      68      ;   
        DW      750     ;   
        DB      8       ;    
        DW      128     ;   
        DB      2       ;  
        DB      2       ;  
        DB      2       ;   
        DB      0       ;  
        DB      0       ; 8- 
        DB      0FFh    ; 
        DB      2       ; 
        DB      80      ;GAP3  /
        DB      80      ;GAP3  
        DB      0       ; 
        DB      0       ;  
        DB      0       ;  

CHed::            ; Edisk RU5/7/2x7
        DB      0FFH    ;+  
        DB      2       ;+  
        DB      0       ;+  
        DB      1       ;-  
        DB      1       ;+   
        DB      0       ;+   
        DW      0       ;+       (seted by mem_size)
        DB      128     ;+    
        DW      128     ;+    
        DB      1       ;+   
        DW      0       ;+   
        DW      0       ;+          (seted by mem_size)
        DW      128     ;+    
        DW      0       ;+         (seted by mem_size)
        DB      8       ;+     
        DW      128     ;+    

MON_SIZE EQU    $-@RUN
        global  mon_size
bss_start   equ $
.DEPHASE

        aseg
        org     bss_start
CHede:  ds      7
CH3:    ds      23h
CH4:    ds      23h
CH5:    ds      23h
CH6:    ds      23h
CH7:    ds      23h
CH8:    ds      23h
CH9:    ds      23h

BUF::   ds      1024         ; Dmon buffer (1024 byte)
bss_end equ     $

bss_lng equ     bss_end-bss_start

        global  bss_lng
        global  bss_start
        global  bss_end

PRINT <Monitor image size - > %(MON_SIZE)
PRINT <Total ram-resident part of rbios - > %(bss_end-@RUN)
PRINT <FREE RAM (FROM TOP) - > %(0FFFFH-bss_end+1)


	aseg
        ORG  3EFFH
MY_R_ADR::DEFW  PTST_1##

pm_rom_tab:
        db      64h,5,2,0,  66h,65h
        db      64h,5,2,80h,66h,65h
pm_ram_ru5:
        db      6,  5,2,0,  6,7
        db      6,  5,2,80h,6,7
pm_ram_ru7:
        db      1ch,5,2,0,  1dh,1eh
        db      1ch,5,2,80h,1dh,1eh

pm_go_tab:
        dw      pm_go_s48
        dw      pm_go_s128
        dw      pm_go_trdos

pm_go_s48:
        out     (c),e
        nop
        ld      a,30h
        ld      bc,7FFDh
        out     (c),a
;        ld      bc,0FF77h
;        out     (c),e
        rst     0

pm_go_s128:
        out     (c),e
        nop
        xor     a
        ld      bc,7FFDh
        out     (c),a
;        ld      bc,0FF77h
;        out     (c),e
        rst     0

pm_go_trdos:
        out     (c),e
        nop
        ld      bc,7FFDh
        ld      a,30h
        out     (c),a
        ld      bc,0
        push    bc
;        ld      bc,0FF77h
;        out     (c),e
        jp      3d2fh
end

