.z80
ks_flag    equ  k_5cnt
_ks_flag   equ  _k_5cnt
ks_fe1     equ  7
_ks_fe0    equ  4

ks_shifts  equ  k_last
_ks_shifts equ  _k_last

_ks_shft   equ  0
_ks_ctrl   equ  1
_ks_alt    equ  2
_ks_caps   equ  3
_ks_num    equ  4
_ks_scroll equ  5

;     k_cnt

keyboard: ld    bc,tlrd
        in      a,(c)
        rla
        ret     nc
        ld      b,high adrd
        in      a,(c)
        ld      h,8

        dec     h
        jr      nz,$-1

        in      a,(c)

        ld      b,8
ks_1:   rra
        rl h
        djnz ks_1

        ld      a,(ks_flag)
        bit     _ks_fe0,a
        jr      nz,ks_e0do
        and     ks_fe1
        jr      z,ks_nxt
        dec     (ix+_ks_flag)
        ret
ks_e0do:res     _ks_fe0,(ix+_ks_flag)
        ld      a,h
        and     7fh
        cp      38h
        jr      z,ks_nxt
        cp      1dh
        jr      z,ks_nxt
        bit     7,h
        ret     nz
        cp      1ch
        jr      z,ks_nxt
        cp      35h
        jr      z,ks_nxt
        sub     47h
        ret     c
        ld      hl,ks_padt
        jp      ks_put1

ks_nxt: ld      a,h
        cp      0bah
        ret     z
        cp      0c6h
        ret     z
        cp      0c5h
        ret     z
        cp      0b8h
        jr      z,ksir_alt
        cp      0b6h
        jr      z,ksir_shft
        cp      0aah
        jr      z,ksir_shft
        cp      09dh
        jr      z,ksir_ctrl
        cp      3ah
        jr      z,ksis_clock
        cp      46h
        jr      z,ksis_slock
        cp      45h
        jr      z,ksis_num
        cp      38h
        jr      z,ksis_alt
        cp      36h
        jr      z,ksis_shft
        cp      2ah
        jr      z,ksis_shft
        cp      1dh
        jr      z,ksis_ctrl
        cp      0e1h
        jr      z,ksis_e1
        cp      0e0h
        jr      nz,ks_no1
        set     _ks_fe0,(ix+_ks_flag)
        ret
ksis_e1:
        ld      (ix+_ks_flag),5
        ret
ksir_alt:
        res     _ks_alt,(ix+_ks_shifts)
        ret
ksir_shft:
        res     _ks_shft,(ix+_ks_shifts)
        ret
ksir_ctrl:
        res     _ks_ctrl,(ix+_ks_shifts)
        ret
ksis_alt:
        set     _ks_alt,(ix+_ks_shifts)
        ret
ksis_shft:
        set     _ks_shft,(ix+_ks_shifts)
        ret
ksis_ctrl:
        set     _ks_ctrl,(ix+_ks_shifts)
        ret
ksis_clock:
        ld      b,1 shl _ks_caps
        jr      ks_lock
ksis_slock:
        ld      b,1 shl _ks_scroll
        jr      ks_lock
ksis_num:
        ld      b,1 shl _ks_num
ks_lock: ld     a,(ks_shifts)
        xor     b
        ld      (ks_shifts),a
        bit     _ks_scroll,b
        ret     z
        bit     _ks_scroll,a
        ld      a,14
        jr      nz,ks_put_it
        inc     a
        jr      ks_put_it
ks_no1: ld      a,h
        or      a
        ret     m
        cp      47h
        ld      hl,ks_baset-1
        jr      c,ks_enc
        ld      hl,ks_numt-47h
        bit     _ks_num,(ix+_ks_shifts)
        jr      nz,ks_enc
        ld      hl,ks_padt-47h
ks_enc: call    add_hl_a
        ld      a,(hl)
        bit     _ks_alt,(ix+_ks_shifts)
        ret     nz
        cp      ' '+1
        jr      c,ks_put_it
        cp      '@'
        jr      c,ks_1pt
        bit     _ks_ctrl,(ix+_ks_shifts)
        jr      z,do_2nctrl
        and     1fh
        jr      ks_put_it
do_2nctrl:
        ld      b,a
        ld      a,(ks_shifts)
        and     (1 shl _ks_caps) + (1 shl _ks_shft)
        ld      a,b
        jp      pe,ks_put_it
        xor     20h
        jr      ks_put_it
ks_1pt: bit     _ks_ctrl,(ix+_ks_shifts)
        ret     nz
        bit     _ks_shft,(ix+_ks_shifts)
        jr      z,ks_put_it
        cp      "'"
        ld      b,'"'
        jr      z,kspitb
        cp      '`'
        ld      b,'~'
        jr      z,kspitb
        ld      hl,ks_altt-','
ks_put1:call    add_hl_a
        ld      a,(hl)
ks_put_it:
        or      a
        ret     z
        ld      b,a
kspitb:ld   a,(tail)
       cp   maxqui
       ld  hl,(beep_t)
       jp   z,beep
       ld   hl,begqui
       call  add_hl_a
       inc  (ix+_tail)
       ld   (hl),b
       push hl
       ld hl,(beep_k)
       call beep
       pop  hl
       ret


ks_baset:db     1bh, '1234567890-=', 8, 9
        db      'qwertyuiop[]', 0dh, 0
        db      "asdfghjkl;'`", 0
        db      '\zxcvbnm,./', 0, '*'
        db      0, ' ', 0
        ds      12
ks_numt:db      '789-456+1230.', 0, 0
ks_padt:db      0,5,18,'-',19,0,4,'+',0,24,3,15,7,0,0
ks_altt:db      '<_>?)!@#$%^&*(',0, ':', 0, '+'

read_k:
        call stat_k
       or   a
       jr   z,read_k

popkey:ld   hl,begqui+1
       ld   de,begqui
       dec  (ix+_tail)
       ld   a,(de)
       ld   bc,maxqui-1
       ldir
       ret

stat_k::ld   a,(tail)
       or   a
       ret  z
       ld   a,0ffh
       ret

