#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

FILE* output;
void PutCode(int l=0, char c=0)	/* output l bits of code c */
{static unsigned putbuf;      // 15 bit |<bits>...| 0 bit
 static char putlen;          //    15> |<-pl->|<-l->|... | <0

 while(putlen>=8)
  {if (putc(putbuf>>8,output)==EOF) perror("Problem writing output file");
   putbuf<<=8; putlen-=8;}

 if (l) putbuf |= c << (16-(putlen+=l)); else
 if (putlen)
  {putlen=0;
   if (putc(putbuf>>8,output)==EOF) perror("Problem writing output file");}
}

inline void emit_byte(char b)
{PutCode(1,0); PutCode(8,b);}

enum Cntrls {C_entry=0,C_common,C_progr,C_reqlib,C_inter,C_comm_size,
C_ext_chain,C_entry_pnt,C_res8,C_ext_off,C_data_size,C_org,C_chain,
C_prog_size,C_prog_end,C_file_end};
enum RelType  {R_abs=0, R_code, R_data, R_comm};
enum ArgTypes {A_name=0, A_begin, A_end, A_size, A_org, Atotal};

void emit_ctrl(char type, unsigned val=0, char rel=R_abs, char* symb=NULL)
{PutCode(1,1); PutCode(2,0); PutCode(4,type);
 if (symb) strupr(symb);
 if (type>=C_comm_size && type<C_file_end)
  {PutCode(2,rel); PutCode(8,val); PutCode(8,val>>8);}
 if (type<C_ext_off)
  {rel=strlen(symb); if (rel>6) rel=6;
   PutCode(3,rel); while(rel--) PutCode(8,*symb++);}
 if (type==C_prog_end) PutCode();
}

char *args[Atotal];
char *args_nm[]={"name", "begin", "end", "size", "org"};
#define name  (args[A_name])
#define begin (args[A_begin])
#define end   (args[A_end])
#define size  (args[A_size])
#define org   (args[A_org])

int strind(char* str, char v)
{char* p=strchr(str,v);
 if (p) return p-str;
 return -1;
}

main(int argc, char** argv)
{char *inp=NULL, *out=NULL, *p; int j;
 for(int i=1;i<argc;++i)
  if (p=strpbrk(argv[i],"=-:"))
   {j=strind("nbeso",tolower(argv[i][0]));
    if (j==-1)   printf("Unknown symbol '%s'\n",argv[i]); else
    if (args[j]) printf("Symbol '%s' already defined as '%s'\n",args_nm[j],args[j]);
    else args[j]=p+1;} else
  if (!inp) inp=argv[i]; else
  if (!out) out=argv[i];
  else printf("Extra parameter '%s' detected\n",argv[i]);
 if (!inp)
  {puts(
    "Usage: abs2rel {<symbols>} <in file> [<out file>]\n"
    " Where <symbols> are:\n"
    "  name=<module name>\n"
    "  begin=<label of module begining>\n"
    "  end=<label of module end>\n"
    "  size=<constant with module size>\n"
    "  org=<module start address>[:<module segment>]\n"
    "         Where <segment> one of:\n"
    "          dseg\n"
    "          cseg\n"
    "          aseg");
   return 1;}

 char _out  [_MAX_PATH];
 char _drive[_MAX_DRIVE];
 char _dir [_MAX_DIR];
 char _file[_MAX_FNAME];
 _splitpath(inp,_drive,_dir,_file,NULL);
 if (!out) _makepath(out=_out,_drive,_dir,_file,".rel");
 if (!name) name=_file;

 unsigned org_v=0; char org_rel=R_code;
 if (org)
  {org_v=strtol(org,&p,16);
   if (*p)
    switch(tolower(p[1]))
     {case 'a': org_rel=R_abs; break;
      case 'c': case 't': case 'p': case 0: org_rel=R_code; break;
      case 'd': org_rel=R_data; break;
      default: printf("Unknown segment '%s'\n",p+1);}}

 FILE* in_f=fopen(inp,"rb");
 if (!in_f) {perror("Can't open input file"); return 1;}
 long fsize=filelength(fileno(in_f))+org_v;
 if (fsize>0x10000l) {printf("Input file too large!\n"); return 1;}
 output=fopen(out,"wb");
 if (!output) {perror("Can't create output file"); return 1;}

 emit_ctrl(C_progr,0,0,name);
 if (begin) emit_ctrl(C_entry,0,0,begin);
 if (end)   emit_ctrl(C_entry,0,0,end);
 if (size)  emit_ctrl(C_entry,0,0,size);
 emit_ctrl(C_data_size,org_rel==R_data?fsize:0);
 if (org_rel==R_code) emit_ctrl(C_prog_size,fsize,R_code);
 emit_ctrl(C_org,org_v,org_rel);
 while((j=getc(in_f))!=EOF) emit_byte(j);
 if (begin) emit_ctrl(C_entry_pnt,org_v,org_rel,begin);
 if (end)   emit_ctrl(C_entry_pnt,fsize,org_rel,end);
 if (size)  emit_ctrl(C_entry_pnt,fsize,R_abs,size);
 emit_ctrl(C_prog_end); emit_ctrl(C_file_end); PutCode();
 PutCode(8,0); PutCode();
 fclose(output); fclose(in_f);
 return 0;
}
