#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include <alloc.h>

FILE* taget;
char tname[80];

char *fname;
unsigned fline;

char def_base=10;

char rlev=0;
char levfence=0;

char far iobuf[0x7fff];

void err(int level, char* str, ...)
{if (rlev<level+1) rlev=level+1;
 switch(level)
  {case 0: printf("*Warning* "); break;
   case 1: printf("**Error** "); break;
   case 2: printf("**Fatal** ");}
 if (fline) printf("In file %s (%d) ",fname,fline);
 putchar(':'); vprintf(str,...); putchar('\n');
 if (level>=2) exit(rlev<levfence?0:rlev);
}

int  int_len;
long get_int(char* &str)
{char* p=str;
 char bstr[33];
 char base=def_base,b,c;
 int i;
 unsigned long l,l1;

 for(i=0;i<32&&isalnum(*p);++p,++i) bstr[i]=*p;
 bstr[i]=0;
 if (isalnum(*p)) {err(0,"Number too long"); while(isalnum(*p)) p++;}
 if (p[-1]!='0' && !strtoul(bstr+i-1,NULL,def_base))
  {bstr[--i]=0; --p;}
 switch(toupper(*p))
  {case 'S': case 'B': base=2;  p++; break;
   case 'H':           base=16; p++; break;
   case '.': case 'D': base=10; p++; break;
   case 'O':           base=8;  p++;}
 for(b=base,c=0;!(b&1);b>>=1,++c);
 if (b!=1) int_len=-1; else int_len=(i*c)>>3;
 str=p;
 l=l1=strtoul(bstr,&p,base);
 if (*p) {err(1,"Wrong number representation"); int_len=0; return 0;}
 if (int_len==-1)
  {int_len=0; while(l1) {l1>>=1; int_len++;}
   int_len>>=3;}
 if (!int_len) int_len=1;
 return l;
}

void W(void* buf, int len)
{if (!len) return;
 if (fwrite(buf,1,len,taget)!=len)
  err(1,"Can't write (%s)",sys_errlist[errno]);
}

void copy_file(char *name)
{FILE* f; char* p; int i;
 if (p=strchr(name,'[')) *p++=0;
 if (!(f=fopen(name,"rb"))) {err(1,"Can't open source file '%s'",name); return;}
 unsigned long l,ll=-1;
 l=coreleft();
 if (l>0x7fff) l=0x7fff;
 setvbuf(f,NULL,_IOFBF,l);
 if (p)
  {if (isxdigit(*p))
    {l=get_int(p);
     if (fseek(f,l,SEEK_SET)) err(2,"Seek falure on source '%s'",name);}
   else l=0;
   switch(*p)
    {case ':' : p++; ll=get_int(p); break;
     case '.': if (p[1]!='.') break; p+=2; ll=get_int(p)-l+1;}
   if (*p!=']') err(1,"']' expected");
   if (!ll) ll=1;}
 while(!feof(f) && ll-- && (i=fgetc(f))!=EOF) W(&i,1);
 fclose(f);
}

void opt(char* str)
{switch(toupper(*str))
  {case 'E': levfence=get_int(str+1); break;
   case 'B': def_base=10; if ((def_base=get_int(str+1))>1) break;
     err(1,"Wrong base"); def_base=10; break;

   default: err(0,"Unknown switch '%s'",str-1);}
}

void do_script(char* sname);

void pars_arg(char* arg)
{switch(*arg)
  {case '/': case '-': opt(arg+1); break;
   case '!': do_script(arg+1); break;
   case '#': if (taget && fclose(taget))
      err(1,"Can't close taget file '%s'",tname);
     strcpy(tname,arg+1);
     if (!(taget=fopen(tname,"r+b")))
      if (!(taget=fopen(tname,"w+b")))
       err(2,"Can't create taget file '%s' (%s)",tname,sys_errlist[errno]);
      else printf("Taget '%s' does not exist. Assume new.\n",tname);
     setvbuf(taget,iobuf,_IOFBF,sizeof(iobuf));
     break;
   case '@': copy_file(arg+1); break;
   default: if (!isalnum(*arg)) {err(0,"Unknown script '%s'",arg); break;}
    long l; int ln,cnt=0;
    if (!taget) {err(0,"Taget undefined. Ignore."); break;}
    l=get_int(arg);
    if (*arg==':')
     {if (fseek(taget,l,SEEK_SET)) err(2,"Seek falure");}
    else
     {ln=int_len; if (*arg=='[') cnt=get_int(arg+1);
      if (!cnt) cnt=1; while(cnt--) W(&l,ln);}}
}

void do_script(char* sname)
{FILE* script; int sfl=fline; char * ssn=fname;
 fline=0;
 if (!(script=fopen(sname,"rt")))
  err(2,"Can't open script file '%s' (%s)",sname,sys_errlist[errno]);
 fname=sname;
 char str[1024],*p;
 while(!feof(script) && fgets(str,1024,script))
  {fline++;
   if (p=strchr(str,';')) *p=0;
   for(p=strtok(str," \t\n");p;p=strtok(NULL," \t\n")) pars_arg(p);}
 fclose(script);
 fline=sfl; fname=ssn;
}

void help()
{puts(
"Usage: wr {<script>|<option>}\n\n"
" where <option> are:\n"
"   -e<lev>  - set exit level threshold\n"
"   -b<num>  - set default number base\n\n"
" and <script> are:\n"
"   !<file>  - include script file\n"
"   #<file>  - define taget for writing\n"
"   <num>:   - define start address\n"
"   <num>    - write value to taget\n"
"   <num>'['<num>']' - fill area in taget\n"
"   @<file><range>   - copy <file> to taget in range\n"
"     range is\n"
"                     - full file\n"
"      [<num>]        - from <num> to end\n"
"      [<num>..<num1>]- in range <num> <num>\n"
"      [<num>:<num1>] - from <num> of <num1> bytes length\n"
"        if first <num> omited - assume 0\n");
}

main()
{if (_argc<2) {help(); return 1;}
 for(int i=1;i<_argc;++i) pars_arg(_argv[i]);
 if (taget && fclose(taget)) err(1,"Can't close taget file '%s'",tname);
 return rlev<levfence?0:rlev;
};
