#ifndef __COMMON__
#define __COMMON__

#define SYS_P0   0A2h
#define SYS_P6   0A6h

.comment @
monitor macro   subr
        local   swp,sw1, sw2
        di
swp:    jp      sw1
sw1:    push    hl
        ld      hl,sw2
        ld      (swp+1),hl
        pop     hl
        ei
        call    subr
        di
        push    hl
        ld      hl,sw1
        ld      (swp+1),hl
        pop     hl
sw2:    ei
        endm
@

monitor macro   subr
        local   sem
        ld      hl,sem
        dec     (hl)
        call    z,subr
        ld      hl,sem
        inc     (hl)
        dseg
sem:    db      1
        cseg
        endm

;-------------------------
; Time diff check (CF if time-out)
t_diff  macro   treshhold
        call    _t_diff##
        db      0,treshhold
        endm

t_sw    macro   timev
        call    _t_sw##
        db      12*timev
        endm

;-------------------------
; Switch entry
sw      macro   ent,addr
        call    _sw##
        dw      ent+1,addr
        endm

;-------------------------
; Int manager manipulator
def_ent macro   e_name
        local   _1
        ld      bc,0
??bc??  defl    $-2
        ld      de,0
??de??  defl    $-2
        ld      hl,0
??hl??  defl    $-2
??ent?? defl    $
ifnb <e_name>
e_name:
endif
        jp      _1
??ret?? defl    $
        ld      (??hl??),hl
        ld      (??de??),de
        ld      (??bc??),bc
        ret
_1:
        endm

wait    macro   time
        local   _1,_2
ifnb <time>
        sw      ??ent?? _1
  _1:
 if time ne 0
        call    _p_cnt##
        dw      time,time
        jp      nz,??ret??
 endif
else
        sw      ??ent?? _1
        jp      ??ret??
_1:
endif
        endm

;---
        extrn   add_hl_a
        extrn   rand

#endif
