.z80
        aseg
        org     0
; FCB structure
dr:     ds      1
name:   ds      8
ext:    ds      3
ex:     ds      1
s1:     ds      1
s2:     ds      1
rc:     ds      1
d0n:    ds      16
cr:     ds      1
r0:     ds      1
r1:     ds      1
r2:     ds      1

        cseg
entry:  ld      ix,ix_base
        ld      sp,stack
        ld      a,(5ch)         ;destination drive
        ld      (dest),a
        ld      hl,6ch
        ld      a,(hl)
        ld      (src),a         ;source drive
        ld      de,FCB_match
        ld      bc,16
        ldir
        ld      hl,FCB_match+name
        ld      a,(hl)
        cp      ' '
        jr      nz,sh1
        ld      de,FCB_match+name+1
        ld      bc,10
        ld      (hl),'?'
        ldir
sh1:    ld      b,0
        ld      hl,81h
        ld      a,(80h)
        ld      c,a
        ld      a,'/'
        cpir
        jr      nz,set_usr
usr_lp: ld      a,(hl)
        inc     hl
        sub     '0'
        jr      c,set_usr
        cp      10
        jr      nc,set_usr
        ld      c,a
        ld      a,b
        add     a,a             ; *2
        add     a,a             ; *4
        add     a,b             ; *5
        add     a,a             ; *10
        add     a,c
        ld      b,a
        jr      usr_lp
set_usr: ld     (ix+_usr),b


; copy
        ld      c,20h
        ld      e,0ffh
        call    5
        ld      (dos_usr),a     ; save current user
cp_usr_lp: ld      c,20h
        ld      e,(ix+_usr)
	bit	4,e		; user > 15 not allowed
	jr	nz,done
        call    5               ; set user for copy
        call    get_dir         ; create dir list
        ld      a,(f_cnt)
        or      a
        jr      z,done
        call    xcopy           ; copy list of files
	inc	(ix+_usr)
	jr	cp_usr_lp	; next user
done:   ld      c,20h
        ld      e,(ix+_dos_usr)
        call    5               ; restore dos usr
        rst     0               ; return to dos

get_dir:ld      c,1ah
        ld      de,80h
        call    5               ; set DMA
        ld      hl,st_buf
        ld      (beg_buf),hl
        ld      (ix+_f_cnt),0
        ld      c,11h
        ld      de,FCB_match
        call    5               ; find first (in default DMA)
srh_lp: cp      0ffh
        ret     z              
        ld      l,a
        ld      h,0
        add     hl,hl
        add     hl,hl
        add     hl,hl
        add     hl,hl
        add     hl,hl
        ld      de,81h
        add     hl,de
        ld      de,(beg_buf)
        ld      bc,8+3
        ldir
        ld      (beg_buf),de
        inc     (ix+_f_cnt)
        ld      c,12h
        ld      de,FCB_match
        call    5               ; find next (in default DMA)
        jr      srh_lp

xcopy:  ld      a,(6)
        ld      h,a
        ld      l,0
        ld      de,(beg_buf)
        xor     a
        sbc     hl,de
        add     hl,hl
        ld      l,h
        rla
        ld      h,a
        ld      (buf_num),hl
        or      l
        ld      de,NoMem_M
        jp      z,err
        ld      hl,st_buf
xcp_lp: ld      de,FCB_in+name
        ld      bc,8+3
        ldir
        push    hl
        xor     a
	ld	(FCB_in+cr),a
        ld      (FCB_in+ex),a
        ld      (FCB_out+cr),a
        ld      hl,FCB_in+name
        ld      de,FCB_out+name
        ld      bc,8+3+1
        ldir
        ld      a,(dest)
        ld      (FCB_out+dr),a
        ld      a,(src)
        ld      (FCB_in+dr),a
        call    copy
	ld	c,6
	ld	e,0ffh
	call	5
	cp	3
	jp	z,0
        pop     hl
        dec     (ix+_f_cnt)
        jr      nz,xcp_lp
        ret

copy:   ld	c,9
	ld	de,p1_M
	call	5
           ; print name
        ld      a,(usr)
        or      a
        daa
        push	af
        add     a,0f0h
        sbc     a,a
        and     11h
        or      ' '
        ld      e,a
	ld	c,2
        call    5
        ld      a,'0'
	pop	de
        or      d
        ld      e,a
	ld	c,2
        call    5
        ld      c,9
	ld	de,p2_M
        call    5
        ld      e,5
        ld      d,8
        ld      b,8+3
        ld      hl,FCB_in+name
pr_nm:  ld      a,(hl)
	inc	hl
	push	hl
	push	bc
        cp      ' '
	jr	z,sh3
	push	de
        ld      e,a
	ld	c,2
        call    5
	pop	de
        jr      sh2
sh3:    inc     e
sh2:    dec	d
	push	de
        ld      e,'.'
        ld      c,2
        call    z,5
	pop	de
	pop	bc
	pop	hl
        djnz    pr_nm
        ld      b,e
l1:     push	bc
	ld	c,2
	ld	e,' '
        call    5
	pop	bc
        djnz    l1
        ld      c,0fh
        ld      de,FCB_in
        call    5               ; open input
        cp      0ffh
        ld      de,NoInp_M
        jp      z,err
        ld      c,13h
        ld      de,FCB_out
        call    5               ; delete if exist
        ld      c,16h
        ld      de,FCB_out
        call    5               ; create file
        cp      0ffh
        ld      de,NoRoom_M
        jp      z,err_F

; copy loop
cp_lp:  ld      bc,(buf_num)
        ld      de,(beg_buf)
rd_lp:  push    bc
        push    de
        ld      c,1ah
        call    5               ; set DMA
        ld      de,FCB_in
        ld      c,14h
        call    5               ; read
        pop     hl
        pop     bc
        or      a
        jr      z,rd_ok
        dec     a
        ld      de,Rd_M
        jp      nz,err_D
        ld      hl,(buf_num)    ; partitialy read
        sbc     hl,bc
        jr      z,cp_done       ; no read realy
        ld      b,h
        ld      c,l
        jr      wr_sh
rd_ok:  ld      de,80h
        add     hl,de
        ex      de,hl           ; next buffer
        dec     bc              ; more exist?
        ld      a,b
        or      c
        jr      nz,rd_lp

        ld      bc,(buf_num)
wr_sh:  ld      de,(beg_buf)
wr_lp:  push    bc
        push    de
        ld      c,1ah
        call    5               ; set DMA
        ld      de,FCB_out
        ld      c,15h
        call    5               ; write
        pop     hl
        pop     bc
        or      a
        ld      de,Wd_M
        jp      nz,err_DF
        ld      de,80h
        add     hl,de
        ex      de,hl           ; next buffer
        dec     bc              ; more exist?
        ld      a,b
        or      c
        jr      nz,wr_lp

        jr      cp_lp
cp_done: ld     c,10h
        ld      de,FCB_out
        call    5               ; close
        ld      de,ErCl_M
        cp      0ffh
        ret     nz
err_DF: ld      hl,0
        push    hl
err_D:  push    de
        ld      de,FCB_out
        ld      c,13h
        call    5               ; delete file
        pop     de
err:    ld      c,9
        jp      5               ; print message
err_F:  ld      hl,0
        push    hl
        jr      err

p1_M:     db    0dh,'[$'
p2_M:     db    '] $'
NoInp_M:  db    'Unable to open input file???',0dh,0ah,'$'
NoRoom_M: db    'No room in directory',0dh,0ah,'$'
Wd_M:     db    'Write fault (disk full?). File deleted',0dh,0ah,'$'
ErCl_M:   db    'Error close file. File deleted',0dh,0ah,'$'
Rd_M:     db    'Error reading file. File deleted',0dh,0ah,'$'
NoMem_M:  db    'No memory for copy user',0dh,0ah,'$'

FCB_in:    ds   r0
FCB_out:   ds   r0
FCB_match: ds   r0



IX_BASE:

DM     MACRO name, size
_&name EQU $-IX_BASE
name:  DEFS size
       ENDM

DM      dos_usr  1
DM      buf_num  2
DM      dest     1
DM      src      1
DM      usr      1
DM      f_cnt    1
DM      beg_buf  2

        ds      30      ; stack
STACK:
ST_BUF:

end entry
